#include <stdio.h>
#include <stdlib.h>

#define SET_FINAL     "FP"
#define SET_INT_FINAL "IP"
#define USE_PRESET_1  "SET1"
#define USE_PRESET_2  "SET2"
#define USE_PRESET_3  "SET3"
#define USE_PRESET_4  "SET4"
#define SENSE_SOL     "SOL1"
#define START_SOL     "SOL2"
#define END_SOL       "SOL3"
#define START_SAND    "SAND1"
#define END_SAND      "SAND2"
#define ACC_LOW       "A5"
#define ACC_HIGH      "A10"

int main(void) {

	char input[20];
	char command[20];
   double pos_fin[3];
   double pos_int[3];
	char * aux;

	// wait for initialization command - blocking
   scanf("%[^\n\r]", input);

	// move to init pos (35, 0, 15)
   printf("Moving robot to 35,0,15");

   // infinite loop for receiving new commands 
   while (1) {

		// wait for command - blocking
		scanf("%s", input);

		if (strcmp(input, SET_FINAL)==0) {
			scanf("%s", command);
			aux = strtok(command, "x");
			sscanf(aux, "%lf", &pos_fin[0]);
			aux = strtok(NULL, "x");
			sscanf(aux, "%lf", &pos_fin[1]);
			aux = strtok(NULL, "x");
			sscanf(aux, "%lf", &pos_fin[2]);
			printf("pos_fin = (%lf, %lf, %lf)\n", pos_fin[0], pos_fin[1], pos_fin[2]);
			/* EXECUTE MOVEMENT...*/
		} else if (strcmp(input, SET_INT_FINAL)==0) {
			scanf("%s", command);
			aux = strtok(command, "x");
			sscanf(aux, "%lf", &pos_fin[0]);
			aux = strtok(NULL, "x");
			sscanf(aux, "%lf", &pos_fin[1]);
			aux = strtok(NULL, "x");
			sscanf(aux, "%lf", &pos_fin[2]);
			printf("pos_fin = (%lf, %lf, %lf)\n", pos_fin[0], pos_fin[1], pos_fin[2]);
			scanf("%s", command);
			aux = strtok(command, "x");
			sscanf(aux, "%lf", &pos_int[0]);
			aux = strtok(NULL, "x");
			sscanf(aux, "%lf", &pos_int[1]);
			aux = strtok(NULL, "x");
			sscanf(aux, "%lf", &pos_int[2]);
			printf("pos_int = (%lf, %lf, %lf)\n", pos_int[0], pos_int[1], pos_int[2]);
			/* EXECUTE MOVEMENT...*/
		} else if (strcmp(input, USE_PRESET_1)==0) {
			printf("Executing preset trajectory 1\n");
			/* READ FROM FILE 1*/
		} else if (strcmp(input, USE_PRESET_2)==0) {
			printf("Executing preset trajectory 2\n");
			/* READ FROM FILE 2*/
		} else if (strcmp(input, USE_PRESET_3)==0) {
			printf("Executing preset trajectory 3\n");
			/* READ FROM FILE 3*/
		} else if (strcmp(input, USE_PRESET_4)==0) {
			printf("Executing preset trajectory 4\n");
			/* READ FROM FILE 4*/
		} else if (strcmp(input, SENSE_SOL)==0) {
			printf("Solar storm coming...\n");
			/* ACTIVATE TMR */
		} else if (strcmp(input, START_SOL)==0) {
			printf("Solar storm started\n");
			/* ACTIVATE EMULATION */
		} else if (strcmp(input, END_SOL)==0) {
			printf("Solar storm ended\n");
			/* DEACTIVATE REDUNDANCY AND EMULATION */
		} else if (strcmp(input, START_SAND)==0) {
			printf("Sand storm started\n");
			/* LOW ENERGY MODE */
		} else if (strcmp(input, END_SAND)==0) {
			printf("Sand storm ended\n");
			/* ACCELERATION */
		} else if (strcmp(input, ACC_LOW)==0) {
			printf("Accuracy level set to LOW\n");
			/* WRITE '5' IN ACC.TXT */
		} else if (strcmp(input, ACC_HIGH)==0) {
			printf("Accuracy level set to HIGH\n");
			/* WRITE '10' IN ACC.TXT */
		} else { // default
			printf("Command %s could not be decoded\n", input);
		} 
	} 

   return 0;
}

void slice_coord(char * str, double * coord) {

	char * aux;
	aux = strtok(str, "x");
	//printf("%s ", aux);
	sscanf(aux, "%lf", &coord[0]);

	aux = strtok(NULL, "x");
	//printf("%s ", aux);
	sscanf(aux, "%lf", &coord[1]);

	aux = strtok(NULL, "x");
	//printf("%s ", aux);
	sscanf(aux, "%lf", &coord[2]);

} 

