##########################################################################
 # 
 # THALES ALENIA SPACE SPAIN CONFIDENTIAL
 # __________________
 # 
 #  
 #  All Rights Reserved.
 # 
 # NOTICE:  All information contained herein is, and remains
 # the property of THALES ALENIA SPACE SPAIN and its suppliers,
 # if any.  The intellectual and technical concepts contained
 # herein are proprietary to THALES ALENIA SPACE SPAIN
 # and its suppliers and may be covered by patents in process, 
 # and are protected by trade secret or copyright law.
 # Dissemination of this information or reproduction of this material
 # is strictly forbidden unless prior written permission is obtained
 # from THALES ALENIA SPACE SPAIN.
 #########################################################################

# imports
import serial
import sys 
from PyQt4 import QtCore, QtGui, uic
from time import sleep

# defines
PORT     = "/dev/ttyACM0"
BAUDRATE = 115200
TIMEOUT  = 20

#global vars
ser = serial.Serial()
qtCreatorFile = "arm_gui_v3.ui" # Enter file here.
Ui_MainWindow, QtBaseClass = uic.loadUiType(qtCreatorFile)

class MyApp(QtGui.QMainWindow, Ui_MainWindow):

    
    def __init__(self):
        QtGui.QMainWindow.__init__(self)
        Ui_MainWindow.__init__(self)
        self.setupUi(self)
        self.startButton.clicked.connect(self.Start)
        self.sendButton.clicked.connect(self.SendValues)
        
        self.sendpreButton.clicked.connect(self.SendpreValues)
        self.SOLsense.clicked.connect(self.solsensef)
        self.SOLstart.clicked.connect(self.solstartf)
        self.SOLstop.clicked.connect(self.solstopf)
        self.SANDstart.clicked.connect(self.sandstartf)
        self.SANDstop.clicked.connect(self.sandstopf)
        self.ACT1.clicked.connect(self.act1f)
        self.ACT2.clicked.connect(self.act2f)
        
        self.comboBox.activated.connect(self.combof)
        self.checkBox.stateChanged.connect(self.checkf)
   
        ser.baudrate = BAUDRATE
        ser.port = PORT
        ser.timeout = TIMEOUT
        self.combo = "Pre-set trajectory 1"
        self.check = False
        
    def Start(self):        
        ser.open()    
        sleep(0.5)
        ser.write("\n\r".encode('ascii'))  
        sleep(0.5)
        ser.write("cd /home/linaro/test_NMp_sender2_testGUI/bin/make\n\r".encode('ascii'))
        sleep(0.5)
        ser.write("stty -F /dev/ttyPS0 500000\n\r".encode('ascii'))  
        sleep(0.5)
        ser.write("./app_v04\n\r".encode('ascii'))  
        sleep(0.5)
        ser.write("\n\r".encode('ascii'))   
        sleep(1)
        ser.close()   
        self.startButton.setEnabled(False)
        self.sendButton.setEnabled(True)
        self.textX.setEnabled(True)
        self.textY.setEnabled(True)
        self.textZ.setEnabled(True)    
        self.textXi.setEnabled(True)
        self.textYi.setEnabled(True)
        self.textZi.setEnabled(True) 
        self.comboBox.setEnabled(True)
        self.checkBox.setEnabled(True)
        
        self.sendpreButton.setEnabled(True)
        self.SOLsense.setEnabled(True)
        self.SOLstart.setEnabled(True)
        self.SOLstop.setEnabled(True)
        self.SANDstart.setEnabled(True)
        self.SANDstop.setEnabled(True)
        self.ACT1.setEnabled(True)
        self.ACT2.setEnabled(True)
        
    def SendValues(self):
        ser.open()
        if self.check == False:
            ser.write(("FP\n").encode('ascii'))
            sleep(0.5)
            ser.write((self.textX.toPlainText() + "x" + self.textY.toPlainText() + "x" + self.textZ.toPlainText() + "\n").encode('ascii'))
        else:
            ser.write(("IP\n").encode('ascii'))
            sleep(0.5)
            ser.write((self.textX.toPlainText() + "x" + self.textY.toPlainText() + "x" + self.textZ.toPlainText() + "\n").encode('ascii'))
            sleep(0.5)        
            ser.write((self.textXi.toPlainText() + "x" + self.textYi.toPlainText() + "x" + self.textZi.toPlainText() + "\n").encode('ascii'))
        ser.close()
        
    def SendpreValues(self):
        ser.open()
        if self.combo == "Pre-set trajectory 1":
            ser.write(("SET1\n").encode('ascii'))
        if self.combo == "Pre-set trajectory 2":
            ser.write(("SET2\n").encode('ascii'))
        if self.combo == "Pre-set trajectory 3":
            ser.write(("SET3\n").encode('ascii'))
        if self.combo == "Pre-set trajectory 4":
            ser.write(("SET4\n").encode('ascii'))
        ser.close()
        
    def solsensef(self):
        ser.open()
        ser.write(("SOL1\n").encode('ascii'))
        ser.close()
            
    def solstartf(self):
        ser.open()
        ser.write(("SOL2\n").encode('ascii'))
        ser.close()
        
    def solstopf(self):
        ser.open()
        ser.write(("SOL3\n").encode('ascii'))
        ser.close()
        
    def sandstartf(self):
        ser.open()
        ser.write(("SAND1\n").encode('ascii'))
        ser.close()
        
    def sandstopf(self):
        ser.open()
        ser.write(("SAND2\n").encode('ascii'))
        ser.close()
        
    def act1f(self):
        ser.open()
        ser.write(("A5\n").encode('ascii'))
        ser.close()
        
    def act2f(self):
        ser.open()
        ser.write(("A10\n").encode('ascii'))
        ser.close()
        
    def combof(self):
        self.combo = str(self.comboBox.currentText())
        
    def checkf(self):
        self.check = self.checkBox.isChecked();

if __name__ == "__main__":
    app = QtGui.QApplication(sys.argv)
    window = MyApp()
    window.show()
    sys.exit(app.exec_())
