#include "costFunction.h"
#include <math.h>
#include <stdio.h>
#include "auxiliars.h"

#if defined (__cplusplus)
extern "C" {
#endif

#include "artico3lib.h"

#if defined (__cplusplus)
}
#endif

//ARTICo3 Global Variables
a3data_t *x_0;
a3data_t *x_1;
a3data_t *x_3;
a3data_t *x_4;
a3data_t *pos_final_1;
a3data_t *pos_final_2;
a3data_t *pos_final_3;
a3data_t *cost;

#define SQUARE(x) ((x)*(x))

//void costFunction(int nbParameters, IN double *simplexVertex, IN double *targetValue, OUT double *functionValueVertex){
void costFunction(int nbParameters, IN point_t *simplexVertices, OUT point_t *simplexVerticesEvaluated){

	//evaluating the function
    double px_04,py_04,pz_04,pz_03;
//    for (int i = 0; i < nbParameters; i++)
//    	printf("\t%f",simplexVertices[0].x[i]);



    px_04 = -0.5e1 * cos(simplexVertices[0].x[0]) * (-0.3e1 * cos(-simplexVertices[0].x[4]) * sin(-simplexVertices[0].x[1]+1.5708) * cos(-simplexVertices[0].x[3]) + 0.3e1 * cos(-simplexVertices[0].x[4]) * cos(-simplexVertices[0].x[1]+1.5708) * sin(-simplexVertices[0].x[3]) + 0.3e1 * sin(-simplexVertices[0].x[4]) * sin(-simplexVertices[0].x[1]+1.5708) * sin(-simplexVertices[0].x[3]) + 0.3e1 * sin(-simplexVertices[0].x[4]) * cos(-simplexVertices[0].x[1]+1.5708) * cos(-simplexVertices[0].x[3]) - 0.3e1 * sin(-simplexVertices[0].x[1]+1.5708) * cos(-simplexVertices[0].x[3]) + 0.3e1 * cos(-simplexVertices[0].x[1]+1.5708) * sin(-simplexVertices[0].x[3]) - sin(-simplexVertices[0].x[1]+1.5708) - 0.3e1 * cos(-simplexVertices[0].x[1]+1.5708));
    py_04 = -0.5e1 * sin(simplexVertices[0].x[0]) * (-0.3e1 * cos(-simplexVertices[0].x[4]) * sin(-simplexVertices[0].x[1]+1.5708) * cos(-simplexVertices[0].x[3]) + 0.3e1 * cos(-simplexVertices[0].x[4]) * cos(-simplexVertices[0].x[1]+1.5708) * sin(-simplexVertices[0].x[3]) + 0.3e1 * sin(-simplexVertices[0].x[4]) * sin(-simplexVertices[0].x[1]+1.5708) * sin(-simplexVertices[0].x[3]) + 0.3e1 * sin(-simplexVertices[0].x[4]) * cos(-simplexVertices[0].x[1]+1.5708) * cos(-simplexVertices[0].x[3]) - 0.3e1 * sin(-simplexVertices[0].x[1]+1.5708) * cos(-simplexVertices[0].x[3]) + 0.3e1 * cos(-simplexVertices[0].x[1]+1.5708) * sin(-simplexVertices[0].x[3]) - sin(-simplexVertices[0].x[1]+1.5708) - 0.3e1 * cos(-simplexVertices[0].x[1]+1.5708));
    pz_04 = -0.15e2 * cos(-simplexVertices[0].x[4]) * sin(-simplexVertices[0].x[1]+1.5708) * sin(-simplexVertices[0].x[3]) - 0.15e2 * cos(-simplexVertices[0].x[4]) * cos(-simplexVertices[0].x[1]+1.5708) * cos(-simplexVertices[0].x[3]) + 0.15e2 * sin(-simplexVertices[0].x[4]) * cos(-simplexVertices[0].x[1]+1.5708) * sin(-simplexVertices[0].x[3]) - 0.15e2 * sin(-simplexVertices[0].x[4]) * sin(-simplexVertices[0].x[1]+1.5708) * cos(-simplexVertices[0].x[3]) - 0.15e2 * cos(-simplexVertices[0].x[1]+1.5708) * cos(-simplexVertices[0].x[3]) - 0.15e2 * sin(-simplexVertices[0].x[1]+1.5708) * sin(-simplexVertices[0].x[3]) - 0.5e1 * cos(-simplexVertices[0].x[1]+1.5708) + 0.15e2 * sin(-simplexVertices[0].x[1]+1.5708);
    pz_03 = -0.15e2 * cos(-simplexVertices[0].x[1]+1.5708) * cos(-simplexVertices[0].x[3]) - 0.15e2 * sin(-simplexVertices[0].x[1]+1.5708) * sin(-simplexVertices[0].x[3]) - 0.5e1 * cos(-simplexVertices[0].x[1]+1.5708) + 0.15e2 * sin(-simplexVertices[0].x[1]+1.5708);

    //printf("\t--->\t%f,%f,%f,%f\n",px_04,py_04,pz_04,pz_03);
    //printf("\t--->\t%f,%f,%f\n",simplexVertices[0].coordinates[0],simplexVertices[0].coordinates[1],simplexVertices[0].coordinates[2]);
    for(int i = 0; i < nbParameters; i++){
    	simplexVerticesEvaluated[0].x[i] = simplexVertices[0].x[i];
    	//printf("\t%f",simplexVerticesEvaluated[0].x[i]);
    }
    for(int i = 0; i < 3; i++){
    	simplexVerticesEvaluated[0].coordinates[i] = simplexVertices[0].coordinates[i];
    }
    //printf("\n");

    simplexVerticesEvaluated[0].fx = SQUARE(((px_04-simplexVertices[0].coordinates[0])))+SQUARE(((py_04-simplexVertices[0].coordinates[1])))+SQUARE(((pz_04-simplexVertices[0].coordinates[2])))+SQUARE(((pz_04-pz_03)));
    //printf("\t--->\t%f\n",simplexVerticesEvaluated[0].fx);
}


double cost_fun_Light(int n, double x[5], double *pos_final) {
    double out;
    double px_04,py_04,pz_04,pz_03;
//    for (int i = 0; i < n; i++)
//    	printf("\t%f",x[i]);
//    printf("\n");



    px_04 = -0.5e1 * cos(x[0]) * (-0.3e1 * cos(-x[4]) * sin(-x[1]+1.5708) * cos(-x[3]) + 0.3e1 * cos(-x[4]) * cos(-x[1]+1.5708) * sin(-x[3]) + 0.3e1 * sin(-x[4]) * sin(-x[1]+1.5708) * sin(-x[3]) + 0.3e1 * sin(-x[4]) * cos(-x[1]+1.5708) * cos(-x[3]) - 0.3e1 * sin(-x[1]+1.5708) * cos(-x[3]) + 0.3e1 * cos(-x[1]+1.5708) * sin(-x[3]) - sin(-x[1]+1.5708) - 0.3e1 * cos(-x[1]+1.5708));
    py_04 = -0.5e1 * sin(x[0]) * (-0.3e1 * cos(-x[4]) * sin(-x[1]+1.5708) * cos(-x[3]) + 0.3e1 * cos(-x[4]) * cos(-x[1]+1.5708) * sin(-x[3]) + 0.3e1 * sin(-x[4]) * sin(-x[1]+1.5708) * sin(-x[3]) + 0.3e1 * sin(-x[4]) * cos(-x[1]+1.5708) * cos(-x[3]) - 0.3e1 * sin(-x[1]+1.5708) * cos(-x[3]) + 0.3e1 * cos(-x[1]+1.5708) * sin(-x[3]) - sin(-x[1]+1.5708) - 0.3e1 * cos(-x[1]+1.5708));
    pz_04 = -0.15e2 * cos(-x[4]) * sin(-x[1]+1.5708) * sin(-x[3]) - 0.15e2 * cos(-x[4]) * cos(-x[1]+1.5708) * cos(-x[3]) + 0.15e2 * sin(-x[4]) * cos(-x[1]+1.5708) * sin(-x[3]) - 0.15e2 * sin(-x[4]) * sin(-x[1]+1.5708) * cos(-x[3]) - 0.15e2 * cos(-x[1]+1.5708) * cos(-x[3]) - 0.15e2 * sin(-x[1]+1.5708) * sin(-x[3]) - 0.5e1 * cos(-x[1]+1.5708) + 0.15e2 * sin(-x[1]+1.5708);
    pz_03 = -0.15e2 * cos(-x[1]+1.5708) * cos(-x[3]) - 0.15e2 * sin(-x[1]+1.5708) * sin(-x[3]) - 0.5e1 * cos(-x[1]+1.5708) + 0.15e2 * sin(-x[1]+1.5708);

//    printf("\t--->\t%f,%f,%f,%f\n",px_04,py_04,pz_04,pz_03);

    out=SQUARE(((px_04-pos_final[0])))+SQUARE(((py_04-pos_final[1])))+SQUARE(((pz_04-pos_final[2])))+SQUARE(((pz_04-pz_03)));


    return out;
}

//
void costFunctionVectorial(int nbParameters, IN point_t *simplexVertices, OUT point_t *simplexVerticesEvaluated){
	unsigned int i = 0;
	for(i=0; i< (nbParameters + 5) ; i++){
		printf("costFunctionVectorial %u\n",i);
		printf("%f %f %f %f %f\n",(float) (simplexVertices + i)->x[0],(float) (simplexVertices + i)->x[1],(float) (simplexVertices + i)->x[2],(float) (simplexVertices + i)->x[3],(float) (simplexVertices + i)->x[4]);
		costFunction(nbParameters,simplexVertices + i, simplexVerticesEvaluated + i);
	}
}

//init for 1 accelerator
void initCostFunction(){
	//printf("----------------------- initARTICo3 -----------------------\n");
	int values = 10; //((argc > 1) && (atoi(argv[1]) > 5)) ? atoi(argv[1]) : 6;

	    artico3_init();

	    artico3_kernel_create("costfunction", 512, 8, 1); //4096

	    artico3_load("costfunction", 0, 0, 0, 0);

	    x_0 = artico3_alloc(10 * sizeof *x_0, "costfunction", "port0", A3_P_I);
	    x_1 = artico3_alloc(10 * sizeof *x_1, "costfunction", "port1", A3_P_I);
	    x_3 = artico3_alloc(10 * sizeof *x_3, "costfunction", "port2", A3_P_I);
	    x_4 = artico3_alloc(10 * sizeof *x_4, "costfunction", "port3", A3_P_I);

	    pos_final_1 = artico3_alloc(10 * sizeof *pos_final_1, "costfunction", "port4", A3_P_I);
	    pos_final_2 = artico3_alloc(10 * sizeof *pos_final_2, "costfunction", "port5", A3_P_I);
	    pos_final_3 = artico3_alloc(10 * sizeof *pos_final_3, "costfunction", "port6", A3_P_I);

	    cost = artico3_alloc(10 * sizeof *cost, "costfunction", "port7", A3_P_O);

	    artico3_kernel_reset("costfunction");
	    a3data_t wcfg[1] = {values};
	    artico3_kernel_wcfg("costfunction", 0, wcfg);
}

////init for 2 accelerator
//void initCostFunction(){
//	//printf("----------------------- initARTICo3 -----------------------\n");
//	int values = 10; //((argc > 1) && (atoi(argv[1]) > 5)) ? atoi(argv[1]) : 6;
//
//	    artico3_init();
//
//	    artico3_kernel_create("costfunction", 512, 8, 1); //4096
//
//	    artico3_load("costfunction", 0, 0, 0, 0);
//	    artico3_load("costfunction", 1, 0, 0, 0);
//
//	    x_0 = artico3_alloc(10 * sizeof *x_0, "costfunction", "port0", A3_P_I);
//	    x_1 = artico3_alloc(10 * sizeof *x_1, "costfunction", "port1", A3_P_I);
//	    x_3 = artico3_alloc(10 * sizeof *x_3, "costfunction", "port2", A3_P_I);
//	    x_4 = artico3_alloc(10 * sizeof *x_4, "costfunction", "port3", A3_P_I);
//
//	    pos_final_1 = artico3_alloc(10 * sizeof *pos_final_1, "costfunction", "port4", A3_P_I);
//	    pos_final_2 = artico3_alloc(10 * sizeof *pos_final_2, "costfunction", "port5", A3_P_I);
//	    pos_final_3 = artico3_alloc(10 * sizeof *pos_final_3, "costfunction", "port6", A3_P_I);
//
//	    cost = artico3_alloc(10 * sizeof *cost, "costfunction", "port7", A3_P_O);
//
//	    artico3_kernel_reset("costfunction");
//	    a3data_t wcfg[2] = {values,values};
//	    artico3_kernel_wcfg("costfunction", 0, wcfg);
//	    //printf("----------------------- END initARTICo3 -----------------------\n");
//}

//~ //init for 3 accelerator
//~ void initCostFunction(){
	//~ //printf("----------------------- initARTICo3 -----------------------\n");
	//~ int values = 10; //((argc > 1) && (atoi(argv[1]) > 5)) ? atoi(argv[1]) : 6;

	    //~ artico3_init();

	    //~ artico3_kernel_create("costfunction", 512, 8, 1); //4096

	    //~ artico3_load("costfunction", 0, 0, 0, 0);
	    //~ artico3_load("costfunction", 1, 0, 0, 0);
	    //~ artico3_load("costfunction", 2, 0, 0, 0);

	    //~ x_0 = artico3_alloc(10 * sizeof *x_0, "costfunction", "port0", A3_P_I);
	    //~ x_1 = artico3_alloc(10 * sizeof *x_1, "costfunction", "port1", A3_P_I);
	    //~ x_3 = artico3_alloc(10 * sizeof *x_3, "costfunction", "port2", A3_P_I);
	    //~ x_4 = artico3_alloc(10 * sizeof *x_4, "costfunction", "port3", A3_P_I);

	    //~ pos_final_1 = artico3_alloc(10 * sizeof *pos_final_1, "costfunction", "port4", A3_P_I);
	    //~ pos_final_2 = artico3_alloc(10 * sizeof *pos_final_2, "costfunction", "port5", A3_P_I);
	    //~ pos_final_3 = artico3_alloc(10 * sizeof *pos_final_3, "costfunction", "port6", A3_P_I);

	    //~ cost = artico3_alloc(10 * sizeof *cost, "costfunction", "port7", A3_P_O);

	    //~ artico3_kernel_reset("costfunction");
	    //~ a3data_t wcfg[3] = {values,values,values};
	    //~ artico3_kernel_wcfg("costfunction", 0, wcfg);
	    //~ //printf("----------------------- END initARTICo3 -----------------------\n");
//~ }

//~ //init for 4 accelerator
//~ void initCostFunction(){
	//~ //printf("----------------------- initARTICo3 -----------------------\n");
	//~ int values = 10; //((argc > 1) && (atoi(argv[1]) > 5)) ? atoi(argv[1]) : 6;

	    //~ artico3_init();

	    //~ artico3_kernel_create("costfunction", 512, 8, 1); //4096

	    //~ artico3_load("costfunction", 0, 0, 0, 0);
	    //~ artico3_load("costfunction", 1, 0, 0, 0);
	    //~ artico3_load("costfunction", 2, 0, 0, 0);
	    //~ artico3_load("costfunction", 3, 0, 0, 0);

	    //~ x_0 = artico3_alloc(10 * sizeof *x_0, "costfunction", "port0", A3_P_I);
	    //~ x_1 = artico3_alloc(10 * sizeof *x_1, "costfunction", "port1", A3_P_I);
	    //~ x_3 = artico3_alloc(10 * sizeof *x_3, "costfunction", "port2", A3_P_I);
	    //~ x_4 = artico3_alloc(10 * sizeof *x_4, "costfunction", "port3", A3_P_I);

	    //~ pos_final_1 = artico3_alloc(10 * sizeof *pos_final_1, "costfunction", "port4", A3_P_I);
	    //~ pos_final_2 = artico3_alloc(10 * sizeof *pos_final_2, "costfunction", "port5", A3_P_I);
	    //~ pos_final_3 = artico3_alloc(10 * sizeof *pos_final_3, "costfunction", "port6", A3_P_I);

	    //~ cost = artico3_alloc(10 * sizeof *cost, "costfunction", "port7", A3_P_O);

	    //~ artico3_kernel_reset("costfunction");
	    //~ a3data_t wcfg[4] = {values,values,values,values};
	    //~ artico3_kernel_wcfg("costfunction", 0, wcfg);
	    //~ //printf("----------------------- END initARTICo3 -----------------------\n");
//~ }

//init for 5 accelerator
//void initCostFunction(){
//	//printf("----------------------- initARTICo3 -----------------------\n");
//	int values = 10; //((argc > 1) && (atoi(argv[1]) > 5)) ? atoi(argv[1]) : 6;
//
//	    artico3_init();
//
//	    artico3_kernel_create("costfunction", 512, 8, 1); //4096
//
//	    artico3_load("costfunction", 0, 0, 0, 0);
//	    artico3_load("costfunction", 1, 0, 0, 0);
//	    artico3_load("costfunction", 2, 0, 0, 0);
//	    artico3_load("costfunction", 3, 0, 0, 0);
//	    artico3_load("costfunction", 4, 0, 0, 0);
//
//	    x_0 = artico3_alloc(10 * sizeof *x_0, "costfunction", "port0", A3_P_I);
//	    x_1 = artico3_alloc(10 * sizeof *x_1, "costfunction", "port1", A3_P_I);
//	    x_3 = artico3_alloc(10 * sizeof *x_3, "costfunction", "port2", A3_P_I);
//	    x_4 = artico3_alloc(10 * sizeof *x_4, "costfunction", "port3", A3_P_I);
//
//	    pos_final_1 = artico3_alloc(10 * sizeof *pos_final_1, "costfunction", "port4", A3_P_I);
//	    pos_final_2 = artico3_alloc(10 * sizeof *pos_final_2, "costfunction", "port5", A3_P_I);
//	    pos_final_3 = artico3_alloc(10 * sizeof *pos_final_3, "costfunction", "port6", A3_P_I);
//
//	    cost = artico3_alloc(10 * sizeof *cost, "costfunction", "port7", A3_P_O);
//
//	    artico3_kernel_reset("costfunction");
//	    a3data_t wcfg[5] = {values,values,values,values,values};
//	    artico3_kernel_wcfg("costfunction", 0, wcfg);
//	    //printf("----------------------- END initARTICo3 -----------------------\n");
//}

//Release Cost Computation Accelerators in ARTICo3
void release_cost_fun_Hw() {

    artico3_free("costfunction", "port0");
    artico3_free("costfunction", "port1");
    artico3_free("costfunction", "port2");
    artico3_free("costfunction", "port3");
    artico3_free("costfunction", "port4");
    artico3_free("costfunction", "port5");
    artico3_free("costfunction", "port6");
    artico3_free("costfunction", "port7");

    artico3_kernel_release("costfunction");

    artico3_exit();

}

double cost_fun_HW(int n, const double *x, double *pos_final) {

    int values;
    values = 1;

    artico3_kernel_reset("costfunction");
    a3data_t wcfg[1] = {values};
    artico3_kernel_wcfg("costfunction", 0, wcfg);



    x_0[0] = ftoa3((float) x[0]);
    x_1[0] = ftoa3((float) x[1]);
    x_3[0] = ftoa3((float) x[3]);
    x_4[0] = ftoa3((float) x[4]);
    pos_final_1[0] = ftoa3((float) pos_final[0]);
    pos_final_2[0] = ftoa3((float) pos_final[1]);
    pos_final_3[0] = ftoa3((float) pos_final[2]);



    //printf("artico3_kernel_execute\n");
    artico3_kernel_execute("costfunction", 1, 1);
    artico3_kernel_wait("costfunction");


    float f_cost = a3tof(cost[0]);

    double cost_HW = (double) f_cost;

    return cost_HW;

}

void cost_fun_HW_MultipleVariable(int values, point_t *inputs) {

    artico3_kernel_reset("costfunction");
    a3data_t wcfg[1] = {values};
    artico3_kernel_wcfg("costfunction", 0, wcfg);

    //filling buffers
    unsigned int variableID = 0;
    for(variableID = 0; variableID < 10 ; variableID++){
    	//
    	x_0[variableID] = ftoa3((float) ((inputs + variableID)->x[0]) );
    	x_1[variableID] = ftoa3((float) ((inputs + variableID)->x[1]) );
    	x_3[variableID] = ftoa3((float) ((inputs + variableID)->x[3]) );
    	x_4[variableID] = ftoa3((float) ((inputs + variableID)->x[4]) );
    	pos_final_1[variableID] = ftoa3((float) (inputs + variableID)->coordinates[0]);
    	pos_final_2[variableID] = ftoa3((float) (inputs + variableID)->coordinates[1]);
    	pos_final_3[variableID] = ftoa3((float) (inputs + variableID)->coordinates[2]);
    	//printf("%f ", (float) ((inputs + variableID)->x[0]) );
    }
    //printf("\n");



    //printf("artico3_kernel_execute\n");
    artico3_kernel_execute("costfunction", 10 /*gsize*/, values/*lsize*/);
    artico3_kernel_wait("costfunction");

    for(variableID = 0; variableID < 10 ; variableID++){
    	(inputs + variableID)->fx = (double) a3tof(cost[variableID]);
    	//printf("%f ", a3tof(cost[variableID]) );
    }
    //printf("\n");

    return;

}

void cost_fun_HW_MultipleVariable2Slots(int values, point_t *inputs) {

    artico3_kernel_reset("costfunction");
    a3data_t wcfg[2] = {values,values};
    artico3_kernel_wcfg("costfunction", 0, wcfg);

    //filling buffers
    unsigned int variableID = 0;
    for(variableID = 0; variableID < 10 ; variableID++){
    	//
    	x_0[variableID] = ftoa3((float) ((inputs + variableID)->x[0]) );
    	x_1[variableID] = ftoa3((float) ((inputs + variableID)->x[1]) );
    	x_3[variableID] = ftoa3((float) ((inputs + variableID)->x[3]) );
    	x_4[variableID] = ftoa3((float) ((inputs + variableID)->x[4]) );
    	pos_final_1[variableID] = ftoa3((float) (inputs + variableID)->coordinates[0]);
    	pos_final_2[variableID] = ftoa3((float) (inputs + variableID)->coordinates[1]);
    	pos_final_3[variableID] = ftoa3((float) (inputs + variableID)->coordinates[2]);
    	//printf("%f ", (float) ((inputs + variableID)->x[0]) );
    }
    //printf("\n");



    //printf("artico3_kernel_execute\n");
    artico3_kernel_execute("costfunction", 10 /*gsize*/, values/*lsize*/);
    artico3_kernel_wait("costfunction");

    for(variableID = 0; variableID < 10 ; variableID++){
    	(inputs + variableID)->fx = (double) a3tof(cost[variableID]);
    	//printf("%f ", a3tof(cost[variableID]) );
    }
    //printf("\n");

    return;

}

// one by one
void costFunctionVectorialARTICo3(int nbParameters, IN point_t *simplexVertices, OUT point_t *simplexVerticesEvaluated){
	unsigned int i = 0;
	for(i=0; i< (nbParameters + 5) ; i++){
		memcpy((void *) simplexVerticesEvaluated + (i * sizeof(point_t)), (void *) simplexVertices+ (i * sizeof(point_t)), sizeof(point_t) ); //
		(simplexVertices + i)->fx = cost_fun_HW(nbParameters,(simplexVertices + i)->x, (simplexVerticesEvaluated + i)->coordinates);
	}
}

// 10 by 10
void costFunctionVectorialARTICo3MultipleVariable(int nbParameters, IN point_t *simplexVertices, OUT point_t *simplexVerticesEvaluated){
	memcpy((void *) simplexVerticesEvaluated, (void *) simplexVertices, sizeof(point_t) * 10 );
	//unsigned int i = 0;
	//for(i=0; i< 10; i++) printVertex(5,(simplexVerticesEvaluated+i));
	//printVertex(int nbParameters, point_t *vertex)
	
	//cost_fun_HW_MultipleVariable(1, simplexVerticesEvaluated);
	cost_fun_HW_MultipleVariable2Slots(5, simplexVerticesEvaluated);

	//for(i=0; i< 10; i++) printVertex(5,(simplexVerticesEvaluated+i));
}
