/*
	============================================================================
	Name        : auxiliars.h
	Author      : Leonardo Suriano
	Version     : 1.0
	Copyright   :
	Description :
	============================================================================
*/

#ifndef AUXILIARS_H
#define AUXILIARS_H

#include "preesm.h"
#include <stdio.h>

void printSimplex(int nbParameters, point_t *simplex);
void printSimplexIteration(int nbParameters, point_t *simplex);
void printVertex(int nbParameters, point_t *vertex);
void replacePoint(int nbParameters, point_t *srcPoint, point_t *destPoint);
void updateSimplex(int nbParameters, point_t *newSimplex, point_t *oldSimplex);
void copyTarget(int nbParameters,point_t *sourcePoint, point_t *destPoint);
double modulus(double x);
void printSimplex72(int nbParameters, simplex_t *simplex);
void printSimplexPlus(int nbParameters, simplexPlus_t *SimplexPlus);
void updateSimplex72(int nbParameters, simplex_t *newSimplex, simplex_t *oldSimplex);
void calculateCONDF(int nbParameters, simplex_t *inputSimplex);
void calculateCONDX(int nbParameters, simplex_t *inputSimplex);
void printAnglesParallel(int ParallelPoints, int nbParameters, simplex_t *inputSimplex);

#define BitVal(data,y) ( (data>>y) & 1)      /** Return Data.Y value   **/
#define SetBit(data,y)    data |= (1 << y)    /** Set Data.Y   to 1    **/
#define ClearBit(data,y)  data &= ~(1 << y)   /** Clear Data.Y to 0    **/
#define TogleBit(data,y)     (data ^=BitVal(y))     /** Togle Data.Y  value  **/
#define Togle(data)   (data =~data )         /** Togle Data value     **/

extern unsigned int segmentCounter;

void PRINTING_MASK_BIT(int ParallelPoints);

#endif //AUXILIARS_H
