/*
	============================================================================
	Name        : conditionreached.h
	Author      : Leonardo Suriano
	Version     : 1.0
	Copyright   :
	Description :
	============================================================================
*/

#ifndef CONDITIONREACHED_H
#define CONDITIONREACHED_H

#include "preesm.h"
#include "auxiliars.h"

#define TOL_X    (0.001) // tolerance on the simplex solutions coordinates
#define TOL_F    (0.001) // tolerance on the function value
#define MAX_ITER (1000)  // maximum number of allowed iterations
#define MAX_EVAL (1000)  // maximum number of allowed function evaluations

extern int preesmStopThreads;

void conditionReached(int nbParameters, IN point_t *updatedSimplex, IN int *iterCount, OUT int *stopReached, OUT point_t *updatedSimplexOut);
void conditionReachedParallel(int nbParameters, int ParallelPoints, IN simplex_t *updatedSimplex, OUT simplex_t *updatedSimplexOut);

#endif // CONDITIONREACHED_H
