#include "centroidParallel.h"
#include "auxiliars.h"
#include <string.h>

void centroid(int nbParameters, IN point_t *sortedSimplex, OUT point_t *centroidVertex){
	//calculating the centroid of the best nbParameters.
	point_t centroid;
    for(int j=0; j<nbParameters; j++) {
    	//the vector is already all 0 because the array is static
    	//centroidVertex[j] = 0;
    	centroid.x[j] = 0;
        for(int i=0; i<nbParameters; i++) {
        	//centroidVertex[0].x[j] += sortedSimplex[i].x[j];
        	centroid.x[j] += sortedSimplex[i].x[j];
        }
        //centroidVertex[0].x[j] /= nbParameters;
        centroid.x[j] = centroid.x[j] / nbParameters;
    }
    //printf("CENTRIOD FUNCTION\n");
    //firing parallel reflections/contractions/extentions
    for(int j = 0; j < nbParameters+1; j++){
    	for(int i=0; i< nbParameters; i++){
    		centroidVertex[j].x[i] = centroid.x[i];
    	}
    }
    for(int i = 0; i < 3; i++){
    	centroidVertex[0].coordinates[i] = sortedSimplex[0].coordinates[i];
    }
}

void centroidOnSimplex(int nbParameters, IN simplex_t *sortedSimplex, OUT point_t *centroidVertex){
	//calculating the centroid of the best nbParameters.
	point_t centroid;
    for(int j=0; j<nbParameters; j++) {
    	//the vector is already all 0 because the array is static
    	centroid.x[j] = 0;
        for(int i=0; i<nbParameters; i++) {
        	centroid.x[j] += sortedSimplex->vertex[i].x[j];
        }
        centroid.x[j] = centroid.x[j] / nbParameters;
    }
    memcpy(centroidVertex[0].x,centroid.x, nbParameters * sizeof(double) );

    // the coordinate are always the same for the whole simplex TODO: use memcpy
    memcpy(centroidVertex[0].coordinates,sortedSimplex->vertex[0].coordinates, 3 * sizeof(double) );
}


void centroidParallel(int nbParameters, int ParallelPoints, IN simplex_t *sortedSimplex, OUT point_t *centroidVertex){
	for(int i = 0; i < ParallelPoints; i++){
		centroidOnSimplex(nbParameters, sortedSimplex+i,centroidVertex+i);
	}
}
