#include "conditionReachedParallel.h"
#include <stdio.h>
#include "auxiliars.h"
#include <assert.h>
#include <stdlib.h>
#include "preesm.h"

extern unsigned int segmentCounter;
extern double copyAngles[5];
extern unsigned int genCommand;

//when StopReached[0] = 1 ---> continue
//when StopReached[0] = 0 ---> stop
int numberIterationPerPoint = 0;


unsigned long long mask_TOL_ = 0xFFFFFFFFFFFFFFFF;
extern unsigned int segmentCounter;
extern unsigned long long mask_TOL_reference;

void conditionReachedParallel(int nbParameters, int ParallelPoints, IN simplex_t *updatedSimplex, OUT simplex_t *updatedSimplexOut){
	assert( (ParallelPoints <= MAX_PARALLEL_POINTS) && "the number of parallel point should be less or equal to 64.\n");
	// controlling the number of iteration
	for(int i = 0; i < ParallelPoints; i++){
		//
		updateSimplex72(nbParameters, updatedSimplexOut + i, updatedSimplex + i);
		if(numberIterationPerPoint > MAX_ITER) {
			// stop if #evals or #iters are greater than the max allowed
		    //printf("StopCondition iter_count reached\n");
		    //exit(1);
		    goto STOP;
		}
		//need to always calculate condf and condx
	}

	//calculating CONDX and CONDF for every simplex (and for every vertex within the simplex)
	for(int i = 0; i < ParallelPoints; i++){
		//
		calculateCONDF(nbParameters, updatedSimplexOut + i );
		calculateCONDX(nbParameters, updatedSimplexOut + i );
//		printf("simplex %d \n",i);
//		printSimplex72(nbParameters, updatedSimplexOut + i);

		if( ( ((updatedSimplexOut + i)->simplexCondX > TOL_X || (updatedSimplexOut + i)->simplexCondF > TOL_F)) == 0 ){
//			printf("(updatedSimplexOut + i)->simplexCondX = %f\n",(updatedSimplexOut + i)->simplexCondX);
//			printf("(updatedSimplexOut + i)->simplexCondF = %f\n",(updatedSimplexOut + i)->simplexCondF);
			ClearBit(mask_TOL_,i);
		}
	}
//	printf("mask_TOL_ : 0x%X\n",mask_TOL_);
//	PRINTING_MASK_BIT(ParallelPoints);
//	printSimplex72(nbParameters, updatedSimplexOut);
	if(mask_TOL_ == mask_TOL_reference){
		goto STOP;
	}


//	CONTINUE:
	numberIterationPerPoint++;
	return;


	STOP:
//	printf("------------------------------------ STOPPING EARLY ----------------------------------\n");
//	printf("---------------------------- %d iteration(s) within segment---------------------------\n",segmentCounter);
//	PRINTING_MASK_BIT(ParallelPoints);
	numberIterationPerPoint=0;

	segmentCounter = 0;
	readCommand = 0;
	genCommand = 0;
	mask_TOL_ = 0xFFFFFFFF;
	copyAngles[0]=	(updatedSimplexOut + (ParallelPoints -1))->vertex[0].x[0] ;
	copyAngles[1]=	(updatedSimplexOut + (ParallelPoints -1))->vertex[0].x[1] ;
	copyAngles[2]=	(updatedSimplexOut + (ParallelPoints -1))->vertex[0].x[2] ;
	copyAngles[3]=	(updatedSimplexOut + (ParallelPoints -1))->vertex[0].x[3] ;
	copyAngles[4]=	(updatedSimplexOut + (ParallelPoints -1))->vertex[0].x[4] ;
	//printf(" %f, %f, %f, %f, %f \n", copyAngles[0],copyAngles[1], copyAngles[2], copyAngles[3], copyAngles[4]);
	printAnglesParallel( ParallelPoints, nbParameters, updatedSimplexOut);

	//exit(0);
	return;
}
