#include "contractionParallel.h"
#include <stdio.h>
#include "auxiliars.h"


#define CONTRACTIONOUTSIDE_COEF (RHO*GAMMA)

void contractionOutside(int nbParameters, IN point_t *inputVertices, IN point_t *centroidVertex, OUT point_t *AcOutside){
	//calculating the contraction of the reflected vertex of the simplex
//	printf("INPUT POINT (NEW)\n");
//	for(int j=0; j<nbParameters; j++){
//		printf("\t%f", inputVertices[0].x[j]);
//	}
//	printf("\n");
//	printf("CENTROID POINT\n");
//	for(int j=0; j<nbParameters; j++){
//		printf("\t%f", centroidVertex[0].x[j]);
//	}
//	printf("\n");
	for(int j=0; j<nbParameters; j++){
		AcOutside[0].x[j] = (1+CONTRACTIONOUTSIDE_COEF)*centroidVertex[0].x[j] - CONTRACTIONOUTSIDE_COEF * inputVertices[nbParameters].x[j];
	}
	copyTarget(nbParameters,inputVertices, AcOutside);
//	printf("CONTRACTION POINT\n");
//	for(int j=0; j<nbParameters; j++){
//		printf("\t%f", Ar[0].x[j]);
//	}
//	printf("\n\n\n");
}

#define CONTRACTIONINSIDE_COEF (-GAMMA)

void contractionInside(int nbParameters, IN point_t *inputVertices, IN point_t *centroidVertex, OUT point_t *AcInside){
	//calculating the contraction of the reflected vertex of the simplex
//	printf("INPUT POINT (NEW)\n");
//	for(int j=0; j<nbParameters; j++){
//		printf("\t%f", inputVertices[0].x[j]);
//	}
//	printf("\n");
//	printf("CENTROID POINT\n");
//	for(int j=0; j<nbParameters; j++){
//		printf("\t%f", centroidVertex[0].x[j]);
//	}
//	printf("\n");
	for(int j=0; j<nbParameters; j++){
		AcInside[0].x[j] = (1+CONTRACTIONINSIDE_COEF)*centroidVertex[0].x[j] - CONTRACTIONINSIDE_COEF * inputVertices[nbParameters].x[j];
	}
	copyTarget(nbParameters,inputVertices, AcInside);
//	printf("CONTRACTION POINT\n");
//	for(int j=0; j<nbParameters; j++){
//		printf("\t%f", Ar[0].x[j]);
//	}
//	printf("\n\n\n");
}

void contractionOutsideSingle(int nbParameters, IN simplex_t *inputVertices, IN point_t *centroidVertex, OUT point_t *AcOutside){
	for(int j=0; j<nbParameters; j++){
		AcOutside[0].x[j] = (1+CONTRACTIONOUTSIDE_COEF)*centroidVertex[0].x[j] - CONTRACTIONOUTSIDE_COEF * inputVertices->vertex[nbParameters].x[j];
	}
	copyTarget(nbParameters,&(inputVertices->vertex[nbParameters]), AcOutside);
}

void contractionOutsideParallel(int nbParameters, int ParallelPoints, IN simplex_t *inputVertices, IN point_t *centroidVertex, OUT point_t *Aco){
	//
	for(int i = 0; i < ParallelPoints; i++){
		contractionOutsideSingle(nbParameters,inputVertices + i ,centroidVertex + i, Aco + i );
	}
}

void contractionInsideSingle(int nbParameters, IN simplex_t *inputVertices, IN point_t *centroidVertex, OUT point_t *AcInside){
	for(int j=0; j<nbParameters; j++){
		AcInside[0].x[j] = (1+CONTRACTIONINSIDE_COEF)*centroidVertex[0].x[j] - CONTRACTIONINSIDE_COEF * inputVertices->vertex[nbParameters].x[j];
	}
	copyTarget(nbParameters,&(inputVertices->vertex[nbParameters]), AcInside);
}

void contractionInsideParallel(int nbParameters, int ParallelPoints, IN simplex_t *inputVertices, IN point_t *centroidVertex, OUT point_t *Aci){
	//
	for(int i = 0; i < ParallelPoints; i++){
		contractionInsideSingle(nbParameters,inputVertices + i ,centroidVertex + i, Aci + i );
		//printVertex( nbParameters, Aci);
	}
}
