#include "costFunctionParallel.h"
#include <math.h>
#include <stdio.h>
#include "auxiliars.h"
#include <string.h>

#if defined (__cplusplus)
extern "C" {
#endif

#include "artico3lib.h"

#if defined (__cplusplus)
}
#endif

//ARTICo3 Global Variables
a3data_t *x_0;
a3data_t *x_1;
a3data_t *x_3;
a3data_t *x_4;
a3data_t *pos_final_1;
a3data_t *pos_final_2;
a3data_t *pos_final_3;
a3data_t *cost;

//const int GlobalValues = 170; // (10 perAccel * 10 parallePoints) = 100
const int simplexPerAccelInit = 10;


#define SQUARE(x) ((x)*(x))

//init for 8 accelerator
//void initCostFunctionParallel(){
//	//printf("----------------------- initARTICo3 -----------------------\n");
//
//
//	artico3_init();
//
//	artico3_kernel_create("costfunction", 512, 8, 1); //4096
//
//	artico3_load("costfunction", 0, 0, 0, 0);
//	artico3_load("costfunction", 1, 0, 0, 0);
//	artico3_load("costfunction", 2, 0, 0, 0);
//	artico3_load("costfunction", 3, 0, 0, 0);
//	artico3_load("costfunction", 4, 0, 0, 0);
//	artico3_load("costfunction", 5, 0, 0, 0);
//	artico3_load("costfunction", 6, 0, 0, 0);
//	artico3_load("costfunction", 7, 0, 0, 0);
//
//	x_0 = artico3_alloc(GlobalValues * sizeof *x_0, "costfunction", "port0", A3_P_I);
//	x_1 = artico3_alloc(GlobalValues * sizeof *x_1, "costfunction", "port1", A3_P_I);
//	x_3 = artico3_alloc(GlobalValues * sizeof *x_3, "costfunction", "port2", A3_P_I);
//	x_4 = artico3_alloc(GlobalValues * sizeof *x_4, "costfunction", "port3", A3_P_I);
//
//	pos_final_1 = artico3_alloc(GlobalValues * sizeof *pos_final_1, "costfunction", "port4", A3_P_I);
//	pos_final_2 = artico3_alloc(GlobalValues * sizeof *pos_final_2, "costfunction", "port5", A3_P_I);
//	pos_final_3 = artico3_alloc(GlobalValues * sizeof *pos_final_3, "costfunction", "port6", A3_P_I);
//
//	cost = artico3_alloc(GlobalValues * sizeof *cost, "costfunction", "port7", A3_P_O);
//
//	artico3_kernel_reset("costfunction");
//	a3data_t wcfg[8] = {simplexPerAccelInit,simplexPerAccelInit,simplexPerAccelInit,simplexPerAccelInit,simplexPerAccelInit,simplexPerAccelInit,simplexPerAccelInit,simplexPerAccelInit};
//	artico3_kernel_wcfg("costfunction", 0, wcfg);
//	//printf("----------------------- END initARTICo3 -----------------------\n");
//}

//init for 1 accelerator
void initCostFunctionParallel(){
	//printf("----------------------- initARTICo3 -----------------------\n");


	artico3_init();

	artico3_kernel_create("costfunction", 512, 8, 1); //4096

	artico3_load("costfunction", 0, 0, 0, 0);
	artico3_load("costfunction", 1, 0, 0, 0);
	artico3_load("costfunction", 2, 0, 0, 0);
	artico3_load("costfunction", 3, 0, 0, 0);
	artico3_load("costfunction", 4, 0, 0, 0);
	artico3_load("costfunction", 5, 0, 0, 0);
	artico3_load("costfunction", 6, 0, 0, 0);
	artico3_load("costfunction", 7, 0, 0, 0);

//	x_0 = artico3_alloc(GlobalValues * sizeof *x_0, "costfunction", "port0", A3_P_I);
//	x_1 = artico3_alloc(GlobalValues * sizeof *x_1, "costfunction", "port1", A3_P_I);
//	x_3 = artico3_alloc(GlobalValues * sizeof *x_3, "costfunction", "port2", A3_P_I);
//	x_4 = artico3_alloc(GlobalValues * sizeof *x_4, "costfunction", "port3", A3_P_I);
//
//	pos_final_1 = artico3_alloc(GlobalValues * sizeof *pos_final_1, "costfunction", "port4", A3_P_I);
//	pos_final_2 = artico3_alloc(GlobalValues * sizeof *pos_final_2, "costfunction", "port5", A3_P_I);
//	pos_final_3 = artico3_alloc(GlobalValues * sizeof *pos_final_3, "costfunction", "port6", A3_P_I);
//
//	cost = artico3_alloc(GlobalValues * sizeof *cost, "costfunction", "port7", A3_P_O);

	artico3_kernel_reset("costfunction");
	a3data_t wcfg[8] = {simplexPerAccelInit,simplexPerAccelInit,simplexPerAccelInit,simplexPerAccelInit,simplexPerAccelInit,simplexPerAccelInit,simplexPerAccelInit,simplexPerAccelInit};
	artico3_kernel_wcfg("costfunction", 0, wcfg);
	//printf("----------------------- END initARTICo3 -----------------------\n");
}
//void costFunction(int nbParameters, IN double *simplexVertex, IN double *targetValue, OUT double *functionValueVertex){
void costFunction(int nbParameters, IN point_t *simplexVertices, OUT point_t *simplexVerticesEvaluated){

	//evaluating the function
    double px_04,py_04,pz_04,pz_03;
//    for (int i = 0; i < nbParameters; i++)
//    	printf("\t%f",simplexVertices[0].x[i]);



    px_04 = -0.5e1 * cos(simplexVertices[0].x[0]) * (-0.3e1 * cos(-simplexVertices[0].x[4]) * sin(-simplexVertices[0].x[1]+1.5708) * cos(-simplexVertices[0].x[3]) + 0.3e1 * cos(-simplexVertices[0].x[4]) * cos(-simplexVertices[0].x[1]+1.5708) * sin(-simplexVertices[0].x[3]) + 0.3e1 * sin(-simplexVertices[0].x[4]) * sin(-simplexVertices[0].x[1]+1.5708) * sin(-simplexVertices[0].x[3]) + 0.3e1 * sin(-simplexVertices[0].x[4]) * cos(-simplexVertices[0].x[1]+1.5708) * cos(-simplexVertices[0].x[3]) - 0.3e1 * sin(-simplexVertices[0].x[1]+1.5708) * cos(-simplexVertices[0].x[3]) + 0.3e1 * cos(-simplexVertices[0].x[1]+1.5708) * sin(-simplexVertices[0].x[3]) - sin(-simplexVertices[0].x[1]+1.5708) - 0.3e1 * cos(-simplexVertices[0].x[1]+1.5708));
    py_04 = -0.5e1 * sin(simplexVertices[0].x[0]) * (-0.3e1 * cos(-simplexVertices[0].x[4]) * sin(-simplexVertices[0].x[1]+1.5708) * cos(-simplexVertices[0].x[3]) + 0.3e1 * cos(-simplexVertices[0].x[4]) * cos(-simplexVertices[0].x[1]+1.5708) * sin(-simplexVertices[0].x[3]) + 0.3e1 * sin(-simplexVertices[0].x[4]) * sin(-simplexVertices[0].x[1]+1.5708) * sin(-simplexVertices[0].x[3]) + 0.3e1 * sin(-simplexVertices[0].x[4]) * cos(-simplexVertices[0].x[1]+1.5708) * cos(-simplexVertices[0].x[3]) - 0.3e1 * sin(-simplexVertices[0].x[1]+1.5708) * cos(-simplexVertices[0].x[3]) + 0.3e1 * cos(-simplexVertices[0].x[1]+1.5708) * sin(-simplexVertices[0].x[3]) - sin(-simplexVertices[0].x[1]+1.5708) - 0.3e1 * cos(-simplexVertices[0].x[1]+1.5708));
    pz_04 = -0.15e2 * cos(-simplexVertices[0].x[4]) * sin(-simplexVertices[0].x[1]+1.5708) * sin(-simplexVertices[0].x[3]) - 0.15e2 * cos(-simplexVertices[0].x[4]) * cos(-simplexVertices[0].x[1]+1.5708) * cos(-simplexVertices[0].x[3]) + 0.15e2 * sin(-simplexVertices[0].x[4]) * cos(-simplexVertices[0].x[1]+1.5708) * sin(-simplexVertices[0].x[3]) - 0.15e2 * sin(-simplexVertices[0].x[4]) * sin(-simplexVertices[0].x[1]+1.5708) * cos(-simplexVertices[0].x[3]) - 0.15e2 * cos(-simplexVertices[0].x[1]+1.5708) * cos(-simplexVertices[0].x[3]) - 0.15e2 * sin(-simplexVertices[0].x[1]+1.5708) * sin(-simplexVertices[0].x[3]) - 0.5e1 * cos(-simplexVertices[0].x[1]+1.5708) + 0.15e2 * sin(-simplexVertices[0].x[1]+1.5708);
    pz_03 = -0.15e2 * cos(-simplexVertices[0].x[1]+1.5708) * cos(-simplexVertices[0].x[3]) - 0.15e2 * sin(-simplexVertices[0].x[1]+1.5708) * sin(-simplexVertices[0].x[3]) - 0.5e1 * cos(-simplexVertices[0].x[1]+1.5708) + 0.15e2 * sin(-simplexVertices[0].x[1]+1.5708);

    //printf("\t--->\t%f,%f,%f,%f\n",px_04,py_04,pz_04,pz_03);
    //printf("\t--->\t%f,%f,%f\n",simplexVertices[0].coordinates[0],simplexVertices[0].coordinates[1],simplexVertices[0].coordinates[2]);
    for(int i = 0; i < nbParameters; i++){
    	simplexVerticesEvaluated[0].x[i] = simplexVertices[0].x[i];
    	//printf("\t%f",simplexVerticesEvaluated[0].x[i]);
    }
    for(int i = 0; i < 3; i++){
    	simplexVerticesEvaluated[0].coordinates[i] = simplexVertices[0].coordinates[i];
    }
    //printf("\n");

    simplexVerticesEvaluated[0].fx = SQUARE(((px_04-simplexVertices[0].coordinates[0])))+SQUARE(((py_04-simplexVertices[0].coordinates[1])))+SQUARE(((pz_04-simplexVertices[0].coordinates[2])))+SQUARE(((pz_04-pz_03)));
    //printf("\t--->\t%f\n",simplexVerticesEvaluated[0].fx);
}


double cost_fun_Light(int n, double x[5], double *pos_final) {
    double out;
    double px_04,py_04,pz_04,pz_03;
//    for (int i = 0; i < n; i++)
//    	printf("\t%f",x[i]);
//    printf("\n");



    px_04 = -0.5e1 * cos(x[0]) * (-0.3e1 * cos(-x[4]) * sin(-x[1]+1.5708) * cos(-x[3]) + 0.3e1 * cos(-x[4]) * cos(-x[1]+1.5708) * sin(-x[3]) + 0.3e1 * sin(-x[4]) * sin(-x[1]+1.5708) * sin(-x[3]) + 0.3e1 * sin(-x[4]) * cos(-x[1]+1.5708) * cos(-x[3]) - 0.3e1 * sin(-x[1]+1.5708) * cos(-x[3]) + 0.3e1 * cos(-x[1]+1.5708) * sin(-x[3]) - sin(-x[1]+1.5708) - 0.3e1 * cos(-x[1]+1.5708));
    py_04 = -0.5e1 * sin(x[0]) * (-0.3e1 * cos(-x[4]) * sin(-x[1]+1.5708) * cos(-x[3]) + 0.3e1 * cos(-x[4]) * cos(-x[1]+1.5708) * sin(-x[3]) + 0.3e1 * sin(-x[4]) * sin(-x[1]+1.5708) * sin(-x[3]) + 0.3e1 * sin(-x[4]) * cos(-x[1]+1.5708) * cos(-x[3]) - 0.3e1 * sin(-x[1]+1.5708) * cos(-x[3]) + 0.3e1 * cos(-x[1]+1.5708) * sin(-x[3]) - sin(-x[1]+1.5708) - 0.3e1 * cos(-x[1]+1.5708));
    pz_04 = -0.15e2 * cos(-x[4]) * sin(-x[1]+1.5708) * sin(-x[3]) - 0.15e2 * cos(-x[4]) * cos(-x[1]+1.5708) * cos(-x[3]) + 0.15e2 * sin(-x[4]) * cos(-x[1]+1.5708) * sin(-x[3]) - 0.15e2 * sin(-x[4]) * sin(-x[1]+1.5708) * cos(-x[3]) - 0.15e2 * cos(-x[1]+1.5708) * cos(-x[3]) - 0.15e2 * sin(-x[1]+1.5708) * sin(-x[3]) - 0.5e1 * cos(-x[1]+1.5708) + 0.15e2 * sin(-x[1]+1.5708);
    pz_03 = -0.15e2 * cos(-x[1]+1.5708) * cos(-x[3]) - 0.15e2 * sin(-x[1]+1.5708) * sin(-x[3]) - 0.5e1 * cos(-x[1]+1.5708) + 0.15e2 * sin(-x[1]+1.5708);

//    printf("\t--->\t%f,%f,%f,%f\n",px_04,py_04,pz_04,pz_03);

    out=SQUARE(((px_04-pos_final[0])))+SQUARE(((py_04-pos_final[1])))+SQUARE(((pz_04-pos_final[2])))+SQUARE(((pz_04-pz_03)));


    return out;
}


void costFunctionSimplexPlus(int nbParameters, int ParallelPoints, IN simplexPlus_t *simplexVertices, OUT simplexPlus_t *simplexVerticesEvaluated){
	//
	costFunction(nbParameters, &(simplexVertices->Ar), &(simplexVerticesEvaluated->Ar));
	costFunction(nbParameters, &(simplexVertices->Ae), &(simplexVerticesEvaluated->Ae));
	costFunction(nbParameters, &(simplexVertices->AcOutside), &(simplexVerticesEvaluated->AcOutside));
	costFunction(nbParameters, &(simplexVertices->AcInside), &(simplexVerticesEvaluated->AcInside));
	costFunction(nbParameters, &(simplexVertices->ShrinkedSimplex.vertex[0]), &(simplexVerticesEvaluated->ShrinkedSimplex.vertex[0]));
	costFunction(nbParameters, &(simplexVertices->ShrinkedSimplex.vertex[1]), &(simplexVerticesEvaluated->ShrinkedSimplex.vertex[1]));
	costFunction(nbParameters, &(simplexVertices->ShrinkedSimplex.vertex[2]), &(simplexVerticesEvaluated->ShrinkedSimplex.vertex[2]));
	costFunction(nbParameters, &(simplexVertices->ShrinkedSimplex.vertex[3]), &(simplexVerticesEvaluated->ShrinkedSimplex.vertex[3]));
	costFunction(nbParameters, &(simplexVertices->ShrinkedSimplex.vertex[4]), &(simplexVerticesEvaluated->ShrinkedSimplex.vertex[4]));
	costFunction(nbParameters, &(simplexVertices->ShrinkedSimplex.vertex[5]), &(simplexVerticesEvaluated->ShrinkedSimplex.vertex[5]));
}

void costFunctionParallel(int nbParameters, int ParallelPoints, IN simplexPlus_t *simplexVertices, OUT simplexPlus_t *simplexVerticesEvaluated){
	//
	for(int i = 0; i < ParallelPoints; i++){
		costFunctionSimplexPlus(nbParameters, ParallelPoints, simplexVertices + i , simplexVerticesEvaluated + i );
	}
}

void cost_fun_HW_MultipleVariable(int values, point_t *inputs) {

    artico3_kernel_reset("costfunction");
    a3data_t wcfg[8] = {values,values,values,values,values,values,values,values};
    artico3_kernel_wcfg("costfunction", 0, wcfg);

    //filling buffers
    unsigned int variableID = 0;
    for(variableID = 0; variableID < 10 ; variableID++){
    	//
    	x_0[variableID] = ftoa3((float) ((inputs + variableID)->x[0]) );
    	x_1[variableID] = ftoa3((float) ((inputs + variableID)->x[1]) );
    	x_3[variableID] = ftoa3((float) ((inputs + variableID)->x[3]) );
    	x_4[variableID] = ftoa3((float) ((inputs + variableID)->x[4]) );
    	pos_final_1[variableID] = ftoa3((float) (inputs + variableID)->coordinates[0]);
    	pos_final_2[variableID] = ftoa3((float) (inputs + variableID)->coordinates[1]);
    	pos_final_3[variableID] = ftoa3((float) (inputs + variableID)->coordinates[2]);
    	//printf("%f ", (float) ((inputs + variableID)->x[0]) );
    }
    //printf("\n");



    //printf("artico3_kernel_execute\n");
    artico3_kernel_execute("costfunction", 10 /*gsize*/, values/*lsize*/);
    artico3_kernel_wait("costfunction");

    for(variableID = 0; variableID < 10 ; variableID++){
    	(inputs + variableID)->fx = (double) a3tof(cost[variableID]);
    	//printf("%f ", a3tof(cost[variableID]) );
    }
    //printf("\n");

    return;

}

void copyAccInputSimplex(int nbParameters, int simplexPlusID, int simplexPerAcc, simplexPlus_t *inputs){
	//Ar
	x_0[simplexPlusID * simplexPerAcc] = ftoa3((float) ((inputs + simplexPlusID)->Ar.x[0]) );
	x_1[simplexPlusID * simplexPerAcc] = ftoa3((float) ((inputs + simplexPlusID)->Ar.x[1]) );
	x_3[simplexPlusID * simplexPerAcc] = ftoa3((float) ((inputs + simplexPlusID)->Ar.x[3]) );
	x_4[simplexPlusID * simplexPerAcc] = ftoa3((float) ((inputs + simplexPlusID)->Ar.x[4]) );
	pos_final_1[simplexPlusID * simplexPerAcc] = ftoa3((float) (inputs + simplexPlusID)->Ar.coordinates[0]);
	pos_final_2[simplexPlusID * simplexPerAcc] = ftoa3((float) (inputs + simplexPlusID)->Ar.coordinates[1]);
	pos_final_3[simplexPlusID * simplexPerAcc] = ftoa3((float) (inputs + simplexPlusID)->Ar.coordinates[2]);
	//Ae
	x_0[simplexPlusID * simplexPerAcc + 1] = ftoa3((float) ((inputs + simplexPlusID)->Ae.x[0]) );
	x_1[simplexPlusID * simplexPerAcc + 1] = ftoa3((float) ((inputs + simplexPlusID)->Ae.x[1]) );
	x_3[simplexPlusID * simplexPerAcc + 1] = ftoa3((float) ((inputs + simplexPlusID)->Ae.x[3]) );
	x_4[simplexPlusID * simplexPerAcc + 1] = ftoa3((float) ((inputs + simplexPlusID)->Ae.x[4]) );
	pos_final_1[simplexPlusID * simplexPerAcc + 1] = ftoa3((float) (inputs + simplexPlusID)->Ae.coordinates[0]);
	pos_final_2[simplexPlusID * simplexPerAcc + 1] = ftoa3((float) (inputs + simplexPlusID)->Ae.coordinates[1]);
	pos_final_3[simplexPlusID * simplexPerAcc + 1] = ftoa3((float) (inputs + simplexPlusID)->Ae.coordinates[2]);
	//AcOutside
	x_0[simplexPlusID * simplexPerAcc + 2] = ftoa3((float) ((inputs + simplexPlusID)->AcOutside.x[0]) );
	x_1[simplexPlusID * simplexPerAcc + 2] = ftoa3((float) ((inputs + simplexPlusID)->AcOutside.x[1]) );
	x_3[simplexPlusID * simplexPerAcc + 2] = ftoa3((float) ((inputs + simplexPlusID)->AcOutside.x[3]) );
	x_4[simplexPlusID * simplexPerAcc + 2] = ftoa3((float) ((inputs + simplexPlusID)->AcOutside.x[4]) );
	pos_final_1[simplexPlusID * simplexPerAcc + 2] = ftoa3((float) (inputs + simplexPlusID)->AcOutside.coordinates[0]);
	pos_final_2[simplexPlusID * simplexPerAcc + 2] = ftoa3((float) (inputs + simplexPlusID)->AcOutside.coordinates[1]);
	pos_final_3[simplexPlusID * simplexPerAcc + 2] = ftoa3((float) (inputs + simplexPlusID)->AcOutside.coordinates[2]);
	//AcInside
	x_0[simplexPlusID * simplexPerAcc + 3] = ftoa3((float) ((inputs + simplexPlusID)->AcInside.x[0]) );
	x_1[simplexPlusID * simplexPerAcc + 3] = ftoa3((float) ((inputs + simplexPlusID)->AcInside.x[1]) );
	x_3[simplexPlusID * simplexPerAcc + 3] = ftoa3((float) ((inputs + simplexPlusID)->AcInside.x[3]) );
	x_4[simplexPlusID * simplexPerAcc + 3] = ftoa3((float) ((inputs + simplexPlusID)->AcInside.x[4]) );
	pos_final_1[simplexPlusID * simplexPerAcc + 3] = ftoa3((float) (inputs + simplexPlusID)->AcOutside.coordinates[0]);
	pos_final_2[simplexPlusID * simplexPerAcc + 3] = ftoa3((float) (inputs + simplexPlusID)->AcOutside.coordinates[1]);
	pos_final_3[simplexPlusID * simplexPerAcc + 3] = ftoa3((float) (inputs + simplexPlusID)->AcOutside.coordinates[2]);
	//ShrinkedSimplex
	for(int vertexInSimplex = 0; vertexInSimplex < nbParameters + 1 ; vertexInSimplex++){
		x_0[simplexPlusID * simplexPerAcc + 4 + vertexInSimplex] = ftoa3((float) ((inputs + simplexPlusID)->ShrinkedSimplex.vertex[vertexInSimplex].x[0]) );
		x_1[simplexPlusID * simplexPerAcc + 4 + vertexInSimplex] = ftoa3((float) ((inputs + simplexPlusID)->ShrinkedSimplex.vertex[vertexInSimplex].x[1]) );
		x_3[simplexPlusID * simplexPerAcc + 4 + vertexInSimplex] = ftoa3((float) ((inputs + simplexPlusID)->ShrinkedSimplex.vertex[vertexInSimplex].x[3]) );
		x_4[simplexPlusID * simplexPerAcc + 4 + vertexInSimplex] = ftoa3((float) ((inputs + simplexPlusID)->ShrinkedSimplex.vertex[vertexInSimplex].x[4]) );
		pos_final_1[simplexPlusID * simplexPerAcc + 4 + vertexInSimplex] = ftoa3((float) (inputs + simplexPlusID)->ShrinkedSimplex.vertex[vertexInSimplex].coordinates[0]);
		pos_final_2[simplexPlusID * simplexPerAcc + 4 + vertexInSimplex] = ftoa3((float) (inputs + simplexPlusID)->ShrinkedSimplex.vertex[vertexInSimplex].coordinates[1]);
		pos_final_3[simplexPlusID * simplexPerAcc + 4 + vertexInSimplex] = ftoa3((float) (inputs + simplexPlusID)->ShrinkedSimplex.vertex[vertexInSimplex].coordinates[2]);
	}
}

void copyAccOutputSimplex(int nbParameters, int simplexPlusID, int simplexPerAcc, simplexPlus_t *inputs){
	//Ar
//	((inputs + simplexPlusID)->Ar.fx) ) = (double) a3tof(cost[simplexPlusID * simplexPerAcc+ 0]);
	(inputs + simplexPlusID)->Ar.fx = (double) a3tof(cost[simplexPlusID * simplexPerAcc+ 0]);
//	//Ae
	((inputs + simplexPlusID)->Ae.fx)  = (double) a3tof(cost[simplexPlusID * simplexPerAcc+ 1]);
//	//AcOutside
	((inputs + simplexPlusID)->AcOutside.fx) = (double) a3tof(cost[simplexPlusID * simplexPerAcc+ 2]);
//	//AcInside
	((inputs + simplexPlusID)->AcInside.fx) = (double) a3tof(cost[simplexPlusID * simplexPerAcc+ 3]);
//	//ShrinkedSimplex
	for(int vertexInSimplex = 0; vertexInSimplex < nbParameters + 1 ; vertexInSimplex++){
//		//
		(inputs + simplexPlusID)->ShrinkedSimplex.vertex[vertexInSimplex].fx = (double) a3tof(cost[simplexPlusID * simplexPerAcc+ 3 + vertexInSimplex]);
	}
}

void cost_fun_HW_Parallel(int nbParameters, int simplexPerAcc, int ParallelPoints, simplexPlus_t *inputs) {
	//printf("cost_fun_HW_Parallel\n");
    artico3_kernel_reset("costfunction");
    a3data_t wcfg[8] = {simplexPerAcc,simplexPerAcc,simplexPerAcc,simplexPerAcc,simplexPerAcc,simplexPerAcc,simplexPerAcc,simplexPerAcc};
    artico3_kernel_wcfg("costfunction", 0, wcfg);

    int GlobalValues = simplexPerAcc * ParallelPoints;

	x_0 = artico3_alloc(GlobalValues * sizeof *x_0, "costfunction", "port0", A3_P_I);
	x_1 = artico3_alloc(GlobalValues * sizeof *x_1, "costfunction", "port1", A3_P_I);
	x_3 = artico3_alloc(GlobalValues * sizeof *x_3, "costfunction", "port2", A3_P_I);
	x_4 = artico3_alloc(GlobalValues * sizeof *x_4, "costfunction", "port3", A3_P_I);

	pos_final_1 = artico3_alloc(GlobalValues * sizeof *pos_final_1, "costfunction", "port4", A3_P_I);
	pos_final_2 = artico3_alloc(GlobalValues * sizeof *pos_final_2, "costfunction", "port5", A3_P_I);
	pos_final_3 = artico3_alloc(GlobalValues * sizeof *pos_final_3, "costfunction", "port6", A3_P_I);

	cost = artico3_alloc(GlobalValues * sizeof *cost, "costfunction", "port7", A3_P_O);

    //filling buffers
    unsigned int simplexPlusID = 0;
    for(simplexPlusID = 0; simplexPlusID < ParallelPoints ; simplexPlusID++){
    	//TODO : to delete the simplexPlusID from within the expression (inputs + simplexPlusID)->
    	copyAccInputSimplex(nbParameters, simplexPlusID, simplexPerAcc, inputs);
    }

    //printf("artico3_kernel_execute\n");
    artico3_kernel_execute("costfunction", simplexPerAcc * ParallelPoints /*gsize*/, simplexPerAcc/*lsize*/);
    artico3_kernel_wait("costfunction");

//    for(variableID = 0; variableID < 10 ; variableID++){
//        	(inputs + variableID)->fx = (double) a3tof(cost[variableID]);
//        	//printf("%f ", a3tof(cost[variableID]) );
//        }

    for(simplexPlusID = 0; simplexPlusID < ParallelPoints ; simplexPlusID++){
    	//copyAccOutputSimplex(int nbParameters, int simplexPlusID, int simplexPerAcc, simplexPlus_t *inputs)
    	copyAccOutputSimplex(nbParameters, simplexPlusID, simplexPerAcc, inputs);
    }
    artico3_free("costfunction","port0");
    artico3_free("costfunction","port1");
    artico3_free("costfunction","port2");
    artico3_free("costfunction","port3");
    artico3_free("costfunction","port4");
    artico3_free("costfunction","port5");
    artico3_free("costfunction","port6");
    artico3_free("costfunction","port7");

    return;

}

double cost_fun_Light_HARDWARE(int n, double x[5], double *pos_final) {
    double out;
    //printf("cost_fun_Light_HARDWARE\n");

    //int simplexPerAcc = 1;

    artico3_kernel_reset("costfunction");
	a3data_t wcfg[8] = {1,1,1,1,1,1,1,1};
	artico3_kernel_wcfg("costfunction", 0, wcfg);

	x_0 = artico3_alloc(1 * sizeof *x_0, "costfunction", "port0", A3_P_I);
	x_1 = artico3_alloc(1 * sizeof *x_1, "costfunction", "port1", A3_P_I);
	x_3 = artico3_alloc(1 * sizeof *x_3, "costfunction", "port2", A3_P_I);
	x_4 = artico3_alloc(1 * sizeof *x_4, "costfunction", "port3", A3_P_I);

	pos_final_1 = artico3_alloc(1 * sizeof *pos_final_1, "costfunction", "port4", A3_P_I);
	pos_final_2 = artico3_alloc(1 * sizeof *pos_final_2, "costfunction", "port5", A3_P_I);
	pos_final_3 = artico3_alloc(1 * sizeof *pos_final_3, "costfunction", "port6", A3_P_I);

	cost = artico3_alloc(1 * sizeof *cost, "costfunction", "port7", A3_P_O);

	x_0[0] = ftoa3((float) x[0]) ;
	x_1[0] = ftoa3((float) x[1]) ;
	x_3[0] = ftoa3((float) x[3]) ;
	x_4[0] = ftoa3((float) x[4]) ;
	pos_final_1[0] = ftoa3((float) pos_final[0]);
	pos_final_2[0] = ftoa3((float) pos_final[1]);
	pos_final_3[0] = ftoa3((float) pos_final[2]);

	artico3_kernel_execute("costfunction", 1, 1);
	artico3_kernel_wait("costfunction");

    out=(double) a3tof(cost[0]);

    artico3_free("costfunction","port0");
	artico3_free("costfunction","port1");
	artico3_free("costfunction","port2");
	artico3_free("costfunction","port3");
	artico3_free("costfunction","port4");
	artico3_free("costfunction","port5");
	artico3_free("costfunction","port6");
	artico3_free("costfunction","port7");


    return out;
}

void costFunctionParallelARTICO3(int nbParameters, int ParallelPoints, IN simplexPlus_t *simplexVertices, OUT simplexPlus_t *simplexVerticesEvaluated){
	memcpy((void *) simplexVerticesEvaluated, (void *) simplexVertices, sizeof(simplexPlus_t) * ParallelPoints );
//	printf("costfun start\n");
//	for(int simplexPlusID = 0; simplexPlusID < ParallelPoints ; simplexPlusID++){
//		//
//		printSimplexPlus(nbParameters, simplexVerticesEvaluated + simplexPlusID);
//	}
	cost_fun_HW_Parallel(nbParameters, 10, ParallelPoints, simplexVerticesEvaluated);
//	printf("costfun end\n");
//	for(int simplexPlusID = 0; simplexPlusID < ParallelPoints ; simplexPlusID++){
//		//
//		printSimplexPlus(nbParameters, simplexVerticesEvaluated + simplexPlusID);
//	}
}
