#include "createVectorEvaluationParallel.h"
#include "auxiliars.h"
#include <stdio.h>
#include <string.h>

void createVectorEvalutation(int nbParameters, IN point_t *Ar, IN point_t *Ae, IN point_t *AcOutside, IN point_t *AcInside, IN point_t *ShrinkedSimplex, OUT point_t *vectorVertices){
	//copy the vertices of the simplex in the right buffer
	memcpy((void *) vectorVertices + (0 * sizeof(point_t)), (void *) Ar, 		sizeof(point_t) ); // pos 0: Ar
	memcpy((void *) vectorVertices + (1 * sizeof(point_t)), (void *) Ae, 		sizeof(point_t) ); // pos 1: Ae
	memcpy((void *) vectorVertices + (2 * sizeof(point_t)), (void *) AcOutside, sizeof(point_t) ); // pos 2: AcOutside
	memcpy((void *) vectorVertices + (3 * sizeof(point_t)), (void *) AcInside, 	sizeof(point_t) ); // pos 3: AcInside
	memcpy((void *) vectorVertices + (4 * sizeof(point_t)), (void *) ShrinkedSimplex, 	sizeof(point_t) * (nbParameters + 1) ); // pos 4: shrinkedSimplex (nbParameters +1 elements)
}


void createVectorEvalutationSingle(int nbParameters, IN point_t *Ar, IN point_t *Ae, IN point_t *AcOutside, IN point_t *AcInside, IN simplex_t *ShrinkedSimplex, OUT simplexPlus_t *vectorVertices){
	//copy the vertices of the simplex in the right buffer
	memcpy(&(vectorVertices->Ar) , 				Ar, 				sizeof(point_t) ); // pos 0: Ar
	memcpy(&(vectorVertices->Ae) , 				Ae, 				sizeof(point_t) ); // pos 1: Ae
	memcpy(&(vectorVertices->AcOutside) , 			AcOutside, 			sizeof(point_t) ); // pos 2: AcOutside
	memcpy(&(vectorVertices->AcInside) , 			AcInside, 			sizeof(point_t) ); // pos 3: AcInside
	memcpy(&(vectorVertices->ShrinkedSimplex) , 	ShrinkedSimplex, 	sizeof(simplex_t)  ); // pos 4: shrinkedSimplex (nbParameters +1 elements)
}

void createVectorEvalutationParallel(int nbParameters, int ParallelPoints, IN point_t *Ar, IN point_t *Ae, IN point_t *Aco, IN point_t *Aci, IN simplex_t *ShrinkedSimplex, OUT simplexPlus_t *vectorVertices){
	//
	for(int i = 0; i < ParallelPoints; i++){
		createVectorEvalutationSingle(nbParameters, Ar + i, Ae + i, Aco + i, Aci + i, ShrinkedSimplex + i, vectorVertices + i );
	}
}
