#include "extensionParallel.h"
#include <stdio.h>
#include "auxiliars.h"

//#define CHI      2 //expantion coef
//void get_point(int n, double *x, double *x_bar, double coeff, double *x_out) {
//    int j;
//    for(j=0; j<n; j++) {
//        x_out[j] = (1+coeff)*x_bar[j] - coeff*x[j];
//    }
//}

#define EXTENSION_COEF (RHO*CHI)

void extension(int nbParameters, IN point_t *inputVertices, IN point_t *centroidVertex, OUT point_t *Ae){
	//calculating the extension of the reflected vertex of the simplex
	//calculating reflection
    //get_point(n, points[n].x, x_bar, RHO, x_r);
//	printf("INPUT POINT (NEW)\n");
//	for(int j=0; j<nbParameters; j++){
//		printf("\t%f", inputVertices[0].x[j]);
//	}
//	printf("\n");
//	printf("CENTROID POINT\n");
//	for(int j=0; j<nbParameters; j++){
//		printf("\t%f", centroidVertex[0].x[j]);
//	}
//	printf("\n");
	for(int j=0; j<nbParameters; j++){
		Ae[0].x[j] = (1+EXTENSION_COEF)*centroidVertex[0].x[j] - EXTENSION_COEF * inputVertices[nbParameters].x[j];
	}
	copyTarget(nbParameters,inputVertices, Ae);
//	printf("EXTENSION POINT\n");
//	for(int j=0; j<nbParameters; j++){
//		printf("\t%f", Ar[0].x[j]);
//	}
//	printf("\n\n\n");
}

void extensionSingle(int nbParameters, IN simplex_t *inputVertices, IN point_t *centroidVertex, OUT point_t *Ae){
	//calculating the extension of the reflected vertex of the simplex
	//calculating reflection
    //get_point(n, points[n].x, x_bar, RHO, x_r);

	for(int j=0; j<nbParameters; j++){
		Ae[0].x[j] = (1+EXTENSION_COEF)*centroidVertex[0].x[j] - EXTENSION_COEF * inputVertices->vertex[nbParameters].x[j];
	}
	copyTarget(nbParameters, &(inputVertices->vertex[nbParameters]), Ae);
}


void extensionParallel(int nbParameters, int ParallelPoints, IN simplex_t *inputVertices, IN point_t *centroidVertex, OUT point_t *Ae){
	//printf("extention\n");
	for(int i = 0; i < ParallelPoints; i++){
		//printSimplex72(nbParameters, simplex_t *simplex);
		extensionSingle(nbParameters,inputVertices + i ,centroidVertex + i, Ae + i );
	}
}
