#include "nelderMeadPathParallel.h"
#include "auxiliars.h"
#include <stdio.h>

int iteration = 0;

//void nelderMeadPath(int nbParameters, IN point_t *Ar, IN point_t *Ae, IN point_t *AcOutside, IN point_t *AcInside, IN point_t *shrinkSimplex, IN point_t *originalSimplex, OUT point_t *updatedSimplex, OUT int *iterCount){
////void nelderMeadPath(int nbParameters, IN point_t *Ar, IN point_t *Ae, IN point_t *Ac, IN point_t *shrinkSimplex, IN point_t *originalSimplex, OUT point_t *updatedSimplex, OUT int *iterCount){
//	//verifying just the right path to take to update the Simplex
//	//the best vertex is originalSimplex[0]
//	iterCount[0] = iteration;
//	iteration++;
//	printf("NM path\n");
//
//	if(Ar[0].fx < originalSimplex[0].fx){
//		//
//		if(Ae[0].fx < Ar[0].fx){
//			// expand
//			//printf("EXPAND\n");
//			replacePoint(nbParameters,Ae,&originalSimplex[nbParameters]);
//			goto END_FUNTION;
//		} else {
//			// reflect
//			//printf("REFLECT\n");
//			replacePoint(nbParameters,Ar,&originalSimplex[nbParameters]);
//			goto END_FUNTION;
//		}
//	} else {
//		if (Ar[0].fx < originalSimplex[nbParameters-1].fx ){
//			// reflect
//			//printf("REFLECT\n");
////			printVertex(nbParameters,Ar);
////			printf("OLD\n");
////			printVertex(nbParameters,&originalSimplex[nbParameters]);
////			printf("NEW\n");
////			printVertex(nbParameters,Ar);
//			replacePoint(nbParameters,Ar,&originalSimplex[nbParameters]);
//			goto END_FUNTION;
//		} else {
//			if (Ar[0].fx < originalSimplex[nbParameters].fx){
//				if(AcOutside[0].fx <= Ar[0].fx){
//					// contract outside
//					//printf("CONTRACT OUTSIDE\n");
//					replacePoint(nbParameters,AcOutside,&originalSimplex[nbParameters]);
//					goto END_FUNTION;
//				} else {
//					//shrink
//					//printf("SHRINK1\n");
//					originalSimplex = shrinkSimplex;
//					goto END_FUNTION;
//				}
//			} else {
//				if (AcInside[0].fx <= originalSimplex[nbParameters].fx) {
//					// contract inside
//					//printf("CONTRACT INSIDE\n");
//					replacePoint(nbParameters,AcInside,&originalSimplex[nbParameters]);
//					goto END_FUNTION;
//				} else {
//					//shrink
//					//printf("SHRINK2\n");
//					originalSimplex = shrinkSimplex;
//					goto END_FUNTION;
//				}
//			}
//		}
//	}
//	END_FUNTION:
//	//printf("UPDATING SIMPLEX\n");
//	updateSimplex(nbParameters, updatedSimplex, originalSimplex);
//	return;
//}


void nelderMeadPathSingle(int nbParameters, IN point_t *Ar, IN point_t *Ae, IN point_t *AcOutside, IN point_t *AcInside, IN simplex_t *shrinkSimplex, IN simplex_t *originalSimplex, OUT simplex_t *updatedSimplex){
//void nelderMeadPath(int nbParameters, IN point_t *Ar, IN point_t *Ae, IN point_t *Ac, IN point_t *shrinkSimplex, IN point_t *originalSimplex, OUT point_t *updatedSimplex, OUT int *iterCount){
	//verifying just the right path to take to update the Simplex
	//the best vertex is originalSimplex[0]

	iteration++;

	if(Ar[0].fx < originalSimplex->vertex[0].fx){
		//
		if(Ae[0].fx < Ar[0].fx){
			// expand
			//printf("EXPAND\n");
			replacePoint(nbParameters,Ae,&(originalSimplex->vertex[nbParameters]));
			goto END_FUNTION;
		} else {
			// reflect
			//printf("REFLECT\n");
			replacePoint(nbParameters,Ar,&(originalSimplex->vertex[nbParameters]));
			goto END_FUNTION;
		}
	} else {
		if (Ar[0].fx < originalSimplex->vertex[nbParameters-1].fx ){
			// reflect
			//printf("REFLECT\n");
//			printVertex(nbParameters,Ar);
//			printf("OLD\n");
//			printVertex(nbParameters,&originalSimplex[nbParameters]);
//			printf("NEW\n");
//			printVertex(nbParameters,Ar);
			replacePoint(nbParameters,Ar,&(originalSimplex->vertex[nbParameters]));
			goto END_FUNTION;
		} else {
			if (Ar[0].fx < originalSimplex->vertex[nbParameters].fx){
				if(AcOutside[0].fx <= Ar[0].fx){
					// contract outside
					//printf("CONTRACT OUTSIDE\n");
					replacePoint(nbParameters,AcOutside,&(originalSimplex->vertex[nbParameters]));
					goto END_FUNTION;
				} else {
					//shrink
					//printf("SHRINK1\n");
					//originalSimplex = shrinkSimplex;  //---------------------------------------controllare!!!!!!!------------------------------
					updateSimplex72(nbParameters, originalSimplex, shrinkSimplex);
					goto END_FUNTION;
				}
			} else {
				if (AcInside[0].fx <= originalSimplex->vertex[nbParameters].fx) {
					// contract inside
					//printf("CONTRACT INSIDE\n");
					replacePoint(nbParameters,AcInside,&(originalSimplex->vertex[nbParameters]));
					goto END_FUNTION;
				} else {
					//shrink
					//printf("SHRINK2\n");
					//originalSimplex = shrinkSimplex; //---------------------------------------controllare!!!!!!!------------------------------
					updateSimplex72(nbParameters, originalSimplex, shrinkSimplex);
					goto END_FUNTION;
				}
			}
		}
	}
	END_FUNTION:
	//printf("UPDATING SIMPLEX\n"); // need to re-sorting the vertex of the simplex, right? to be controlled!!!
	//sortingSimplexInit(nbParameters, originalSimplex, updatedSimplex);
	updateSimplex72(nbParameters, updatedSimplex, originalSimplex);
	return;
}

void nelderMeadPathParallel(int nbParameters, int ParallelPoints, IN point_t *Ar, IN point_t *Ae, IN point_t *AcOutside, IN point_t *AcInside, IN simplex_t *shrinkSimplex, IN simplex_t *originalSimplex, OUT simplex_t *updatedSimplex){
	//
	for(int i = 0; i < ParallelPoints; i++){
		nelderMeadPathSingle(nbParameters, Ar + i, Ae + i, AcOutside + i, AcInside + i, shrinkSimplex + i, originalSimplex + i, updatedSimplex + i);
	}
}
