#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <assert.h>
#include "preesm.h"
#include "readPoints.h"
#include "auxiliars.h"

#define MAX_CHARS (1024)

long int size10elements = 0;
unsigned int readCommand = 0; // when 0 read. When 1 NO.
int startProgram = 0;
unsigned long long mask_TOL_reference = 0xFFFFFFFFFFFFFFFF;

const char* getfield(char* line, int num)
{
    const char* tok;
    for (tok = strtok(line, ",");
         tok && *tok;
         tok = strtok(NULL, ",\n"))
    {
        if (!num--)
            return tok;
    }
    return NULL;
}

//extern unsigned int mask_TOL_reference;
void setupMask_TOL_reference(int ParallelPoints){
	//MAX_PARALLEL_POINTS
	mask_TOL_reference = 0xFFFFFFFFFFFFFFFF;
	for(int i = 0; i< ParallelPoints; i++){
		//
		ClearBit(mask_TOL_reference,i);
	}
}

void readPoints(int nbParameters, int CodomainDim, int ParallelPoints, int TotalPoints, OUT double *X, OUT double *Y, OUT double *Z) {

    //char fileName[MAX_CHARS] = "/home/leonardo/Documents/nelderMeadDevelop/neldermead_completeapplication/reading_point/input_points.csv";
	char fileName[MAX_CHARS] = "/home/linaro/reading_point/input_points.csv";
	if(startProgram == 0){
		gettimeofday(&t0, NULL);
		startProgram++;
	}

    char line[MAX_CHARS];
    //printf("%s",fileName);
    FILE *fptr;
    //char c;
    int i = 0;
    //int count_line = 0;


    if(readCommand == 0){
    	//printf("before\n");
    	//PRINTING_mask_TOL_reference(ParallelPoints);
    	setupMask_TOL_reference(ParallelPoints);
    	//printf("after\n");
    	//PRINTING_mask_TOL_reference(ParallelPoints);
    	readCommand++;
    	//printf("starting reading file.\n");
		fptr = fopen(fileName,"r");
		if(fptr == NULL) {
			printf("Error opening file!\n");
			exit(1);
		}


		// Extract characters from file and store in character c
		//for (c = getc(fptr); c != EOF; c = getc(fptr))
		//	if (c == '\n') // Increment count if this character is newline
		//		count_line = count_line + 1;

		//printf("size10elements = %ld\n",size10elements);

		// rewind file pointer to the right position
		if ( fseek(fptr, size10elements, SEEK_SET) != 0 ) {
			/* Handle repositioning error */
			printf("%s\n","[XML PARSING ERROR] impossible to rewind the file pointer to the beginning");
		}

		//double X[N_POINTS], Y[N_POINTS],Z[N_POINTS];


		while (fgets(line, 1024, fptr))
		{
			char* tmp0 = strdup(line);
			char* tmp1 = strdup(line);
			char* tmp2 = strdup(line);
			X[i] = strtod(getfield(tmp0, 0), NULL);
			//printf("X[i] = %f\n",X[i]);
			Y[i] = strtod(getfield(tmp1, 1), NULL);
			Z[i] = strtod(getfield(tmp2, 2), NULL);
//			printf("%f %f %f\n\n\n\n\n",X[i],Y[i],Z[i]);
			// NOTE strtok clobbers tmp
			free(tmp0);
			free(tmp1);
			free(tmp2);
			i++;
			if(i == ParallelPoints)
				break;
		}
		if(i != ParallelPoints){
//			gettimeofday(&t0, NULL);
//			....
			gettimeofday(&tf, NULL);
			t_hw = ((tf.tv_sec - t0.tv_sec) * 1000.0) + ((tf.tv_usec - t0.tv_usec) / 1000.0);
			printf("Total execution time: %.6f ms\n", t_hw);
			printf("NO MORE POINTS TO BE PROCESSED\n");
			exit(0);
		}

		size10elements = ftell(fptr);
		//printf("size10elements = %ld\n",size10elements);

		//assert(i != count_line && "A is not equal to B");

		fclose(fptr);
    }
    return;
}
