#include "reflectionParallel.h"
#include <stdio.h>
#include "auxiliars.h"

void reflection(int nbParameters, IN point_t *inputVertices, IN point_t *centroidVertex, OUT point_t *Ar){
	//calculating the reflected vertex of the simplex
	//calculating reflection
    //get_point(n, points[n].x, x_bar, RHO, x_r);
//	printf("INPUT POINT (NEW)\n");
//	for(int j=0; j<nbParameters; j++){
//		printf("\t%f", inputVertices[0].x[j]);
//	}
//	printf("\n");
//	printf("CENTROID POINT\n");
//	for(int j=0; j<nbParameters; j++){
//		printf("\t%f", centroidVertex[0].x[j]);
//	}
//	printf("\n");
	for(int j=0; j<nbParameters; j++){
		Ar[0].x[j] = (1+RHO)*centroidVertex[0].x[j] - RHO * inputVertices[nbParameters].x[j];
	}
	copyTarget(nbParameters,inputVertices, Ar);
//	printf("REFLECTION POINT\n");
//	for(int j=0; j<nbParameters; j++){
//		printf("\t%f", Ar[0].x[j]);
//	}
//	printf("\n\n\n");
}

void reflectionSinle(int nbParameters, IN simplex_t *inputVertices, IN point_t *centroidVertex, OUT point_t *Ar){
	//iterate over all the vertices of a single simplex at the time
//	printf("whole simplex\n");
//	printSimplex72(nbParameters, inputVertices);
	for(int j=0; j<nbParameters; j++){
		Ar[0].x[j] = (1+RHO)*centroidVertex[0].x[j] - RHO * inputVertices->vertex[nbParameters].x[j];
	}
	copyTarget(nbParameters,&(inputVertices->vertex[nbParameters]), Ar);
	//TOBEDELETED: copy fx
//	Ar->fx = inputVertices->vertex[nbParameters].fx;
//	printf("Ar\n");
//	printVertex(nbParameters, Ar);
}

void reflectionParallel(int nbParameters, int ParallelPoints, IN simplex_t *inputVertices, IN point_t *centroidVertex, OUT point_t *Ar){
	//printf("reflectionParallel\n");
	//iterate over multiple simplex at the time
	for(int i = 0; i < ParallelPoints; i++){
		//printSimplex72(nbParameters, simplex_t *simplex);
		reflectionSinle(nbParameters,inputVertices + i ,centroidVertex + i, Ar + i );
	}
}
