#include "shrinkParallel.h"
#include "auxiliars.h"
#include <stdio.h>
#include <string.h>

//#define SIGMA    0.5 //reduction coef
//void get_point(int n, double *x, double *x_bar, double coeff, double *x_out) {
//    int j;
//    for(j=0; j<n; j++) {
//        x_out[j] = (1+coeff)*x_bar[j] - coeff*x[j];
//    }
//}

void shrink(int nbParameters, int CodomainDim, IN point_t *inputVertices, IN point_t *centroidVertex, OUT point_t *newSimplex){
	//calculating shrink

	//coping first best element
	for(int i = 0; i < (1); i++){
		//iterating upon the element of a vertex of the simplex
		for(int j = 0; j < nbParameters; j++){
			newSimplex[0].x[j] = inputVertices[0].x[j] ;
		}
		//iterating on the variable of the final point (all identical among themselves)
		for(int k = 0; k < CodomainDim; k++){
			newSimplex[0].coordinates[k] = inputVertices[0].coordinates[k];
		}
	}

	//iterating upon every vertex (but the first best one)
	for(int i = 1; i < (nbParameters + 1); i++){
		//iterating upon the element of a vertex of the simplex
		for(int j = 0; j < nbParameters; j++){
			newSimplex[i].x[j] = inputVertices[0].x[j] + SIGMA * (inputVertices[i].x[j] - inputVertices[0].x[j]);
		}
		//iterating on the variable of the final point (all identical among themselves)
		for(int k = 0; k < CodomainDim; k++){
			newSimplex[i].coordinates[k] = inputVertices[0].coordinates[k];
		}
	}
}

void shrinkSingle(int nbParameters, IN simplex_t *inputVertices, IN point_t *centroidVertex, OUT simplex_t *newSimplex){
	//calculating shrink

	//coping first best element
	memcpy(&(newSimplex->vertex[0]),&(inputVertices->vertex[0]),sizeof(simplex_t));

	//iterating upon every vertex (but the first best one)
	for(int i = 1; i < (nbParameters + 1); i++){
		//iterating upon the element of a vertex of the simplex
		for(int j = 0; j < nbParameters; j++){
			newSimplex->vertex[i].x[j] = inputVertices->vertex[0].x[j] + SIGMA * (inputVertices->vertex[i].x[j] - inputVertices->vertex[0].x[j]);
		}
		//iterating on the variable of the final point (all identical among themselves)
		memcpy( newSimplex->vertex[i].coordinates, inputVertices->vertex[i].coordinates, 3 * sizeof(double) );
	}
}

void shrinkParallel(int nbParameters, int ParallelPoints, IN simplex_t *inputVertices, IN point_t *centroidVertex, OUT simplex_t *newSimplex){
	for(int i = 0; i < ParallelPoints; i++){
		//shrinkSingle(int nbParameters, IN simplex_t *inputVertices, IN point_t *centroidVertex, OUT simplex_t *newSimplex)
		shrinkSingle(nbParameters, inputVertices + i, centroidVertex + i, newSimplex +i);
	}
}
