#include "simplexGenParallel.h"
#include "costFunctionParallel.h"
#include "auxiliars.h"
#include <stdio.h>

unsigned int genCommand = 0;

void simplexGenSingle(int nbParameters, int CodomainDim, int ParallelPoints, IN double *X, IN double *Y, IN double *Z, double *initAngles, simplex_t *simplex){
	//generating a simplex of #(nbParameters+1) vertices. Each vertex has #(nbParameters) number of variables
	for(int i = 0; i < (nbParameters+1);i++){
		for(int j = 0; j < (nbParameters); j++){
//			simplex->vertex[i].x[j] = (i-1==j)? ( initAngles[j]!=0? 1.05*initAngles[j] : 0.00025 ) : initAngles[j];
			simplex->vertex[i].x[j] = (i-1==j)? ( initAngles[j]!=0? 1.5*initAngles[j] : 0.005 ) : initAngles[j];
			//printf("%f\t",simplex[(i*nbParameters) + j]);
		}
		//printf("\n");
		//for(int m = 0; m < (CodomainDim); m++){
		simplex->vertex[i].coordinates[0]=X[0];
		simplex->vertex[i].coordinates[1]=Y[0];
		simplex->vertex[i].coordinates[2]=Z[0];
		//}
		//printf("\n");
		//double cost_fun_Light(int n, const double *x, double *pos_final);
		double out;
		out = cost_fun_Light_HARDWARE(nbParameters, simplex->vertex[i].x, simplex->vertex[i].coordinates);
		simplex->vertex[i].fx = out;
	}
}

void simplexGenParallel(int nbParameters, int CodomainDim, int ParallelPoints, int TotalPoints, IN double *initAngles, IN double *X, IN double *Y, IN double *Z, OUT simplex_t *simplex){
	int i = 0;
	//printf("----------------------- simplexGen -----------------------\n");
	if(genCommand == 0){
		genCommand++;
		for(i = 0; i < ParallelPoints; i++){
			//printf("i=%d\n",i);
			simplexGenSingle(nbParameters, CodomainDim, ParallelPoints, &X[i], &Y[i], &Z[i], initAngles, &simplex[i]);
			//printf("end i=%d\n",i);
		}
	}
	//printf("-----------------------END simplexGen -----------------------\n");
}
