#include "sortingSimplexParallel.h"
#include "auxiliars.h"
#include <stdio.h>
#include <string.h>

int compare(const void *arg1, const void *arg2) {
    double fx1, fx2;
    fx1 = (((point_t *)arg1)->fx);
    fx2 = (((point_t *)arg2)->fx);
    return (fx1<fx2)? -1 : 1;
//    if(fx1==fx2) {
//        return 0;
//    } else {
//        return (fx1<fx2)? -1 : 1;
//    }
}

void sortingSimplexInit(int nbParameters, IN simplex_t *simplexVerticesEvaluated, OUT simplex_t *sortedSimplex){
	memcpy( sortedSimplex  , simplexVerticesEvaluated , sizeof(simplex_t) ); // copy the whole simplex (6 vertex)
	//sorting the vertices within the simplex
	qsort((void *)sortedSimplex, nbParameters+1, sizeof(point_t), compare);

}

void sortingSimplexParallelInit(int nbParameters, int ParallelPoints, IN simplex_t *simplexVerticesEvaluated, OUT simplex_t *sortedSimplex){
	for(int i=0; i<ParallelPoints; i++){
		sortingSimplexInit(nbParameters,simplexVerticesEvaluated+i,sortedSimplex+i);
	}
}
