#include "splitVectorVerticesParallel.h"
#include "auxiliars.h"
#include <stdio.h>
#include <string.h>

void splitVectorVertices(int nbParameters, IN point_t *vectorEvaluated, OUT point_t *Ar, OUT point_t *Ae, OUT point_t *AcOutside, OUT point_t *AcInside, OUT point_t *ShrinkedSimplex){
	//copy the vertices of the simplex in the right buffer
	memcpy((void *) Ar, 		(void *) vectorEvaluated + (0 * sizeof(point_t)), sizeof(point_t) ); // pos 0: Ar
	memcpy((void *) Ae, 		(void *) vectorEvaluated + (1 * sizeof(point_t)), sizeof(point_t) ); // pos 1: Ae
	memcpy((void *) AcOutside,  (void *) vectorEvaluated + (2 * sizeof(point_t)), sizeof(point_t) ); // pos 2: AcOutside
	memcpy((void *) AcInside, 	(void *) vectorEvaluated + (3 * sizeof(point_t)), sizeof(point_t) ); // pos 3: AcInside
	memcpy((void *) ShrinkedSimplex, 	(void *) vectorEvaluated + (4 * sizeof(point_t)), sizeof(point_t) * (nbParameters + 1) ); // pos 4: shrinkedSimplex (nbParameters +1 elements)
}


void splitVectorVerticesSingle(int nbParameters, IN simplexPlus_t *vectorEvaluated, OUT point_t *Ar, OUT point_t *Ae, OUT point_t *AcOutside, OUT point_t *AcInside, OUT simplex_t *ShrinkedSimplex){
	//copy the vertices of the simplex in the right buffer
	memcpy( Ar, 				&(vectorEvaluated->Ar) ,				sizeof(point_t) ); // pos 0: Ar
	memcpy( Ae, 				&(vectorEvaluated->Ae) ,				sizeof(point_t) ); // pos 1: Ae
	memcpy( AcOutside,  		&(vectorEvaluated->AcOutside) ,		sizeof(point_t) ); // pos 2: AcOutside
	memcpy( AcInside, 			&(vectorEvaluated->AcInside) ,			sizeof(point_t) ); // pos 3: AcInside
	memcpy( ShrinkedSimplex, 	&(vectorEvaluated->ShrinkedSimplex) ,	sizeof(simplex_t) ); // pos 4: shrinkedSimplex (nbParameters +1 elements)
}

void splitVectorVerticesParallel(int nbParameters, int ParallelPoints, IN simplexPlus_t *vectorEvaluated, OUT point_t *Ar, OUT point_t *Ae, OUT point_t *AcOutside, OUT point_t *AcInside, OUT simplex_t *ShrinkedSimplex){
	//
	for(int i = 0; i < ParallelPoints; i++){
		//
		splitVectorVerticesSingle(nbParameters, vectorEvaluated + i, Ar + i, Ae + i, AcOutside + i, AcInside + i, ShrinkedSimplex + i);
	}
}
